#include <fstream.h>
#include <alloc.h>
#include <process.h>

#define filein "sam.in"
#define fileout "sam.out"
#define maxn 105
#define nagyprim 4999999
#define maxch 105
#define VAROSKEZD "VALCEAUADESPICATA"
#define VAROSVEGZ "MUNTELEOSANDEI"

void kezdoertek();
void kiszamol(int);
void kiir();

struct eltype {
  long cs;
  eltype *kov;
};

int utsz;
int n, honnan, hova;
eltype *el[maxn];
long csucs[maxn];
char s[maxch];
int kiszamolva[maxn];
int ut[maxn];

int main() {
  kezdoertek();
  kiszamolva[honnan]=1;
  ut[honnan]=1;
  kiszamol(hova);
  kiir();
  return 0;
}

unsigned long ert(char *s) {
  unsigned long fv=0;

  for (; *s; s++) ((fv<<=8)+=*s)%=nagyprim;
  return fv;
}

int sorsz(unsigned long ert) {
  int q;
  for (q=0; q<n; q++)
    if (ert==csucs[q]) return q;
  csucs[n]=ert;
  return n++;
}

void kiszamol(int cs) {
  if (!kiszamolva[cs]) {
    eltype *aktel;

    kiszamolva[cs]=1;
    for (aktel=el[cs]; aktel; aktel=aktel->kov) {
      kiszamol(aktel->cs);
      ut[cs]+=ut[aktel->cs];
    }
  }
}

void kiir() {
  ofstream fout(fileout);
  fout << ut[hova];
  fout.close();
}

void kezdoertek() {
  int q, cs1, cs2;
  long csert1, csert2;
  eltype *aktel;
  ifstream fin(filein);

  fin >> utsz;
  for (q=0; q<utsz; q++) {
    fin >> s;
    cs1=sorsz(csert1=ert(s));
    fin >> s;
    cs2=sorsz(csert2=ert(s));

    if (!(aktel=(eltype *)malloc(sizeof(eltype)))) {
      cout << "Not enough memory!\n";
      exit(1);
    }

    aktel->cs=cs1;
    aktel->kov=el[cs2];
    el[cs2]=aktel;

  }

  fin.close();

  honnan=sorsz(ert(VAROSKEZD));
  hova=sorsz(ert(VAROSVEGZ));
}