#pragma option -O2 -f287 -ff
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXREP (102)
#define MAXC (102)
#define DIMH (9901)
#define SURSA "VALCEAUADESPICATA"
#define DEST "MUNTELEOSANDEI"
#define FIN "sam.in"
#define FOUT "sam.out"

typedef char TNume[MAXC+1];

struct hash_rec {
                TNume nume;
                int nr;
                hash_rec* next;
       } * hash[DIMH];

unsigned long nr_dr=0;
int m, n, numb=0, srs, dest;
int vecini[MAXREP+1][MAXREP+1];
int nr_v[MAXREP+1], nr_tat[MAXREP+1];
unsigned long ajung[MAXREP+1];
int queue[MAXREP+1], head, tail;

int hash_code(TNume nume) {
    int l=strlen(nume);
    unsigned long code=0;
    for (int i=0; i<l; i++) {
        code=(code*71+(nume[i]-'A'))%DIMH;
    }
    return abs(int(code%DIMH));
}

void init_neigh() {
     for (int i=0; i<=MAXREP; i++) {
         nr_tat[i]=nr_v[i]=ajung[i]=0;
     }
}

void init_hash() {
     for (int i=0; i<DIMH; i++) hash[i]=NULL;
}

int find_str(TNume nume, int code) {
    hash_rec* aux=hash[code];
    while (aux) {
          if (0==strcmp(aux->nume,nume)) return aux->nr;
          aux=aux->next;
    }
    return -1;
}

inline int add_str(TNume nume, int code) {
       hash_rec* aux=hash[code];
       hash[code]=new hash_rec;
       hash[code]->next=aux;
       strcpy(hash[code]->nume,nume);
       return hash[code]->nr=++numb;
}

inline int find_num(TNume nume) {
       int h_code=hash_code(nume);
       int nr=find_str(nume,h_code);
       if (nr>=0) return nr;
       return add_str(nume,h_code);
}

inline void add_neigh(int n1, int n2) {
       vecini[n1][ ++nr_v[n1] ]=n2;
}

void read() {
     init_hash();
     init_neigh();
     FILE* in=fopen(FIN,"rt");
     fscanf(in,"%d",&m);
     numb=0;
     for (int i=1; i<=m; i++) {
         TNume num1, num2;
         fscanf(in,"%s %s",num1,num2);
         int nr1=find_num(num1), nr2=find_num(num2);
         add_neigh(nr1,nr2);
     }
     srs=find_num(SURSA);
     dest=find_num(DEST);
     n=numb;
     fclose(in);
}

void write() {
     FILE* out=fopen(FOUT,"wt");
     fprintf(out,"%lu",nr_dr);
     fclose(out);
}

void init_tat() {
     for (int i=1; i<=n; i++) {
         for (int j=1; j<=nr_v[i]; j++)
             nr_tat[ vecini[i][j] ]++;
     }
}

inline void init_queue(int n1) {
       queue[1]=n1;
       head=1; tail=2;
}

inline int behead() {
       return queue[head++];
}

inline void add_queue(int n) {
       queue[tail++]=n;
}

void solve() {
     init_tat();
     init_queue(srs);
     ajung[srs]=1;
     int crt=behead();
     while (crt!=dest) {
           for (int i=1; i<=nr_v[crt]; i++) {
               int v=vecini[crt][i];
               if (--nr_tat[v]==0) add_queue(v);
               ajung[v]+=ajung[crt];
           }
           crt=behead();
     }
     nr_dr=ajung[dest];
}

void main() {
     read();
     solve();
     write();
}