// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la finala 
//   Concursului International de Programare "Bursele Agora" si a functionat 
//   corect in toate aceste situatii.

#include <stdio.h>
#include <mem.h>

#define INFINIT 1000000

const int p[37][7]={ // configuratiile posibile de amplasare a bombelor
  {0,0,0,0,0,0,0},
  {1,1,0,0,0,0,0},
  {0,1,1,0,0,0,0},
  {0,0,1,1,0,0,0},
  {0,0,0,1,1,0,0},
  {0,0,0,0,1,1,0},
  {0,0,0,0,0,1,1},
  {1,1,1,0,0,0,0},
  {1,1,1,1,0,0,0},
  {1,1,0,1,1,0,0},
  {1,1,0,0,1,1,0},
  {1,1,0,0,0,1,1},
  {0,1,1,1,0,0,0},
  {0,1,1,1,1,0,0},
  {0,1,1,0,1,1,0},
  {0,1,1,0,0,1,1},
  {0,0,1,1,1,0,0},
  {0,0,1,1,1,1,0},
  {0,0,1,1,0,1,1},
  {0,0,0,1,1,1,0},
  {0,0,0,1,1,1,1},
  {0,0,0,0,1,1,1},
  {1,1,1,1,1,0,0},
  {1,1,1,0,1,1,0},
  {1,1,1,0,0,1,1},
  {1,1,1,1,1,1,0},
  {1,1,1,1,0,1,1},
  {1,1,0,1,1,1,0},
  {1,1,0,1,1,1,1},
  {1,1,0,0,1,1,1},
  {0,1,1,1,1,1,0},
  {0,1,1,1,0,1,1},
  {0,1,1,1,1,1,1},
  {0,1,1,0,1,1,1},
  {0,0,1,1,1,1,1},
  {1,1,1,0,1,1,1},
  {1,1,1,1,1,1,1}
};

const int nr[37] = {0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4}; // numarul de bombe pentru fiecare configuratie

int X[100][7]; // matricea de intrare
long A[101][37], B[101][37]; // matricele folosite pentru rezolvare
int n; // numarul de linii ale matricei
int k; // numarul de bombe disponibile

void CitesteDate(void){
  FILE *f=fopen("DUNE.IN","rt");
  fscanf(f,"%d%d",&n,&k);
  for (int i=0;i<n;i++)
    for (int j=0;j<7;j++)
      fscanf(f,"%d",&X[i][j]);
}

void DeterminaSolutia(void){
  int valAdaugata1[37][37]; // valAdaugata1[i][j] = valoarea adaugata pe linia curenta daca pe linia curenta este configuratia i, iar pe linia anterioara este configuratia j
  int valAdaugata2[37]; // valAdaugata2[i] = valoarea adaugata pe linia urmatoare daca pe linia curenta este configuratia i
  // initializare
  for (int i=0;i<=k;i++)
    for (int j=0;j<37;j++)
      A[i][j] = -INFINIT;
  A[0][0] = 0;
  for (int linie = 1; linie < n; linie++){
    // se calculeaza valoarea adaugata pe linia curenta de configuratia i daca pe linia anterioara se afla configuratia j
    for (i = 0;i<37;i++)
      for (int j = 0;j<37;j++){
	valAdaugata1[i][j] = 0;
	for (int l = 0; l < 7;l++)
	  if (p[i][l] && !p[j][l]) // configuratia curenta implica adaugarea valorii de pe coloana l a liniei curenta si valoarea nu a fost adaugata datorita configuratiei j de pe linia anterioara
	    valAdaugata1[i][j] += X[linie-1][l]; // liniile incep de la 0, dar linie ia valori de la 1
      }
    // se calculeaza valoarea adaugata pe linia urmatoare de configuratia i
    for (i = 0; i < 37 ;i++){
      valAdaugata2[i] = 0;
      for (int l = 0; l < 7;l++)
	if (p[i][l])
	  valAdaugata2[i] += X[linie][l]; // configuratia curenta implica adaugarea valorii de pe coloana l a liniei urmatoare
    }
    // se determina continutul matricei B
    for (i = 0; i<=k;i++)
      for (int j = 0; j < 37;j++)
	B[i][j] = -INFINIT;
    for (i = 0; i<=k;i++)
      for (int j = 0; j<37;j++)
	if (i>=nr[j]){
	  int q = valAdaugata2[j];
	  int ind = i - nr[j];
	  for (int l=0;l<37;l++){
	    long sum = A[ind][l]+q+valAdaugata1[j][l];
	    if (sum>B[i][j])
	      B[i][j] = sum;
	  }
	}
    memcpy(A,B,sizeof(A));
  }
}

void ScrieSolutia(void){
  FILE *f=fopen("DUNE.OUT","wt");
  long max = 0;
  for (int i = 1;i<=k;i++)
    for (int j=0;j<37;j++)
      if (A[i][j]>max)
	max = A[i][j];
  fprintf(f,"%ld",max);
  fclose(f);
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
  ScrieSolutia();
}