// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la finala 
//   Concursului International de Programare "Bursele Agora" si a functionat 
//   corect in toate aceste situatii.

#include "zavor.h"
#include <stdio.h>
#include <string.h>

char parolaCorecta[102]; // parola corecta
char parolaAlternativa[203]; // o parola alternativa de deschidere
int n; // lungimea parolei corecte

void CitesteDate(void){
  FILE *f=fopen("TEST.IN","rt");
  fscanf(f,"%s",parolaCorecta);
  n = strlen(parolaCorecta);
  strcat(parolaCorecta,"#"); // ultima cifra ar trebui sa duca automatul in starea de eroare
  fclose(f);
}

void ScrieSolutia(void){
  FILE *f=fopen("TEST.OUT","wt");
  fprintf(f,"%s",parolaAlternativa);
  fclose(f);
  exit(0); // daca se determina o parola alternativa, executia programului se intrerupe
}

void ScrieCorect(void){
  FILE *f=fopen("TEST.OUT","wt");
  fprintf(f,"CORECT"); // daca nu a fost detectata nici o parola alternativa inseamna ca cifrul functioneaza corect
  fclose(f);
}

void Situatia1(void){
  // se verifica daca o stare intermediara este stare de deschidere
  ResetA();
  for (int i = 0; i < n - 1; i++){
    Schimba(parolaCorecta[i]);
    if (Deschide() == 'D'){
      memmove(parolaAlternativa,parolaCorecta,i+1);
      parolaAlternativa[i+1] = 0;
      ScrieSolutia();
    }
  }
}

void Situatia2(void){
  // se verifica daca doua stari intermediare sunt identice (se poate sari peste anumite stari intermediare)
  // se verifica toate perechile (i,j) pentru care i < j
  for (int i = 0; i < n; i++)
    for (int j = i + 1; j <= n; j++){
      ResetA();
      for (int k = 0; k < i; k++)
	Schimba(parolaCorecta[k]);
      for (k = j; k < n; k++)
	Schimba(parolaCorecta[k]);
      if (Deschide() == 'D'){
	memmove(parolaAlternativa,parolaCorecta,i);
	memmove(parolaAlternativa+i,parolaCorecta+j,n-j);
	parolaAlternativa[i+n-j] = 0;
	ScrieSolutia();
      }
    }
}

void Situatia3(void){
  // se verifica daca alegerea unui semnal eronat duce intotdeauna automatul in starea de eroare
  // se verifica toate tripletele i, j, k pentru care k != parolaCorecta[i]
  for (int i=0; i<=n; i++)
    for (char k='0'; k<='9'; k++)
      if (k != parolaCorecta[i])
	for (int j=0; j<=n; j++){
	  ResetA();
	  for (int l=0;l<i;l++)
	    Schimba(parolaCorecta[l]);
	  Schimba(k);
	  for (l=j;l<n;l++)
	    Schimba(parolaCorecta[l]);
	  if (Deschide() == 'D'){
	    memmove(parolaAlternativa,parolaCorecta,i);
	    parolaAlternativa[i] = k;
	    memmove(parolaAlternativa+i+1,parolaCorecta+j,n-j);
	    parolaAlternativa[i+n-j+1] = 0;
	    ScrieSolutia();
	  }
	}
}

void Situatia4(void){
  // se verifica daca se poate reveni din starea de eroare
  // se verifica toate perechile i, j
  char z = parolaCorecta[0]=='0'?'1':'0';
  for (char j='0'; j<='9'; j++)
    for (int i=0; i<=n; i++){
      Schimba(z); // se trece in starea de eroare (daca astfel nu se ajunge in starea de eroare, cazul a fost detectat in situatiile anterioare)
      Schimba(j);
      for (int k=i;k<n;k++)
	Schimba(parolaCorecta[k]);
      if (Deschide() == 'D'){
	parolaAlternativa[0]=z;
	parolaAlternativa[1]=j;
	memmove(parolaAlternativa+2,parolaCorecta+i,n-i);
	parolaAlternativa[n-i+2] = 0;
	ScrieSolutia();
      }
    }
}

void DeterminaSolutia(void){
  Situatia1();
  Situatia2();
  Situatia3();
  Situatia4();
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
  ScrieCorect();
}