{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65521,0,655360}

Program WarCraft;
type world=array[0..51,0..51] of Integer;
type crom=record
            penalty:Longint;
            w:world;
          end;
const POP_MAX = 50;
var m,n,gen:Integer;
    a,b,c:world;
    pop:array[1..POP_MAX] of ^crom;
    t:longint absolute $0:$046c;
    init,time,tmax:longint;
    total,nn:Integer;

procedure ReadData;
var f:text;
    s:string;
    i,j:Integer;
begin
  assign(f,'warcraft.in');
  reset(f);
  readln(f,m,n);
  for i:=1 to m do
  begin
    readln(f,s);
    for j:=1 to n do
      if s[j]='+' then a[i][j]:=1
      else a[i][j]:=0
  end;
  for i:=1 to m do
  begin
    a[i][0]:=-1;
    a[i][n+1]:=-1
  end;
  for i:=0 to n+1 do
  begin
    a[0][i]:=-1;
    a[m+1][i]:=-1;
  end;
  close(f);
end;

procedure Fill(x,y,t,nr:Integer);
begin
  b[x][y]:=nr;
  Inc(nn);
  if (b[x+1][y]=t) then Fill(x+1,y,t,nr);
  if (b[x-1][y]=t) then Fill(x-1,y,t,nr);
  if (b[x][y+1]=t) then Fill(x,y+1,t,nr);
  if (b[x][y-1]=t) then Fill(x,y-1,t,nr);
end;

function Evaluate:Longint;
var pen,nr:Longint;
    i,j,tip:Integer;
begin
  nr:=0; pen:=0;
  for i:=1 to m do
    for j:=1 to n do
      if b[i][j]<>a[i][j] then inc(pen);
  for i:=1 to m do
    for j:=1 to n do
    begin
       if (b[i][j]=0) or (b[i][j]=1) then
       begin
         tip:=b[i][j];
         Inc(nr);
         nn:=0;
         Fill(i,j,b[i][j],nr+2);
         inc(pen,m*n);
       end
    end;
  Evaluate:=pen;
end;

procedure BuildPopulation;
var i:Integer;
    pen:Longint;
begin
  b:=a;
  init:=Evaluate;
  for i:=1 to POP_MAX do
  begin
    New(pop[i]);
    with pop[i]^ do
    begin
      w:=a;
      penalty:=init
    end
  end
end;

procedure Mutation;
var i,x1,y1,x2,y2:byte;
begin
  repeat
    x1:=random(m)+1;
    y1:=random(n)+1;
  until b[x1][y1]=1;
  repeat
    x2:=random(m)+1;
    y2:=random(n)+1;
  until b[x2][y2]=0;
  b[x1][y1]:=0;
  b[x2][y2]:=1;
end;

procedure NewGeneration;
var i:Integer;
    pen:Longint;
begin
  inc(gen);
  for i:=1 to POP_MAX do
  begin
    b:=pop[i]^.w;
    Mutation;
    c:=b;
    pen:=Evaluate;
    if pen<=pop[i]^.penalty then
    begin
      pop[i]^.w:=c;
      pop[i]^.penalty:=pen;
    end
  end
end;

procedure WriteSolution;
var f:text;
    min:Longint;
    ind,i,j:Integer;
begin
  assign(f,'WARCRAFT.OUT');
  rewrite(f);
  min:=pop[1]^.penalty;
  ind:=1;
  for i:=2 to POP_MAX do
    if pop[i]^.penalty<min then
      begin min:=pop[i]^.penalty; ind:=i; end;
  total:=0;
  for i:=1 to m do
    for j:=1 to n do
      if pop[ind]^.w[i][j]<>a[i][j] then inc(total);
  writeln(f,total div 2);
  close(f)
end;

begin
  time:=t;
  tmax:=t+18;
  randomize;
  ReadData;
  BuildPopulation;
  while (t<=tmax) do
    NewGeneration;
  WriteSolution
end.