{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$I-,R-,Q-,N+}
{$M 30000,0,655360}

Program FUNCTIE;

uses FUNC;

const filein='FUNCTION.IN';
      fileout='FUNCTION.OUT';
      MAXR=1000;
      MAXIT=50;
      MAXNI=15000;
      MAXBI=80000;
      MULT=1e5;
      eps:real=1e-5;
      deps:real=1e-8;
      timelimit=52;

var root:array[1..MAXR] of real;
    i,j,k,m,n,p,q,nrt,maxi:integer;
    a,b,pas,v,sol,solant,li,ls,fli,fls,fsol:real;
    found:boolean;

    t2:longint absolute 0:$046c;
    t1:longint;

function df(x,fx:real):real;
begin
df:=(f(x+deps)-fx)/(deps);
end;

function NEWTON(xst:real):real;
var nit:integer;
    x0,dfx0,fx0:real;
    ok:boolean;

begin
nit:=0;
x0:=xst;
ok:=(abs(f(x0))<eps);

while (nit<MAXIT) and (not ok) do
  begin
    fx0:=f(x0);
    dfx0:=df(x0,fx0);

    if (abs(dfx0)<deps) then
      begin
        x0:=x0+eps;
      end
    else
      begin
        x0:=x0-fx0/dfx0;
        if (x0<li) or (x0>ls) then
          break;

        ok:=(abs(fx0)<eps);
      end;

    inc(nit);
  end;

if (ok) then
  begin
    NEWTON:=x0;
    if (nit>maxi) then
      maxi:=nit;
  end
else
  NEWTON:=a-1;
end;

function exista(x:real):boolean;
var ok:boolean;
    c:integer;
    vv,vr:longint;
    vaux:real;

begin
ok:=false;

x:=x*MULT;
vv:=round(x);

for c:=nrt downto 1 do
  begin
    vaux:=root[c]*MULT;
    vr:=round(vaux);

    if (vr=vv) then
      begin
        ok:=true;
        break;
      end;
  end;

exista:=ok;
end;

procedure printsol;
begin
assign(output,fileout);
rewrite(output);
writeln(nrt);

for i:=1 to nrt do
  writeln(root[i]:0:5);
{
writeln(t2-t1);
}
close(output);
halt(0);
end;

begin
t1:=t2;

assign(input,filein);
reset(input);
readln(a,b);
close(input);

maxi:=0;
nrt:=0;
pas:=(b-a)/MAXNI;
v:=a;

while (v<b) do
  begin
    { Metoda NEWTON-RAPHSON }

    li:=v; ls:=v+pas;

    sol:=NEWTON((li+ls)/2);

    if (sol>=a) and (sol<=b) then
      begin
        sol:=round(sol*MULT)/MULT;
        solant:=sol-eps;

        while (sol<=b) and (abs(f(sol))<eps) and (not exista(sol)) do
          begin
            inc(nrt);
            root[nrt]:=sol;
            sol:=sol+eps;
            sol:=sol*MULT;
            sol:=round(sol)/MULT;
          end;

        sol:=solant;

        while (sol>=a) and (abs(f(sol))<eps) and (not exista(sol)) do
          begin
            inc(nrt);
            root[nrt]:=sol;
            sol:=sol-eps;
            sol:=sol*MULT;
            sol:=round(sol)/MULT;
          end;
      end;

    { END Metoda NEWTON-RAPHSON }

    if (t2-t1>=timelimit) then
      printsol;

    v:=v+pas;
  end;

pas:=(b-a)/MAXBI;
if (pas<eps) then
  pas:=eps;

v:=b;
while (v>a) do
  begin
    { Metoda bisectiei }

    li:=v-pas; ls:=v;
    fli:=f(li); fls:=f(ls);

    if (fli*fls<=0) and (li>=a) then
      begin
        sol:=(li+ls)/2;
        fsol:=f(sol);

        while (abs(fsol)>=eps) do
          begin
            if (fli*fsol<0) then
              begin
                ls:=sol;
                fls:=fsol;
              end
            else
              begin
                li:=sol;
                fli:=fsol;
              end;

            sol:=(li+ls)/2;
            fsol:=f(sol);
          end;

        sol:=round(sol*MULT)/MULT;
        solant:=sol-eps;

        while (sol<=b) and (abs(f(sol))<eps) and (not exista(sol)) do
          begin
            inc(nrt);
            root[nrt]:=sol;
            sol:=sol+eps;
            sol:=sol*MULT;
            sol:=round(sol)/MULT;
          end;

        sol:=solant;

        while (sol>=a) and (abs(f(sol))<eps) and (not exista(sol)) do
          begin
            inc(nrt);
            root[nrt]:=sol;
            sol:=sol-eps;
            sol:=sol*MULT;
            sol:=round(sol)/MULT;
          end;
      end;

    { END Metoda bisectiei }

    if (t2-t1>=timelimit) then
      printsol;

    v:=v-pas;
  end;

printsol;
end.