{$N+}
Program _SOLVE_LINEAR_EQS;

const term=['=',#13,#10];
      digits=['0'..'9'];
      eps:extended=1e-13;
      epsrez:extended=1e-2;
      MAXN=101;
      setnum=2;

var eq,eqini,inv:array[1..MAXN,0..MAXN] of extended;
    v,nt,max:array[1..MAXN] of longint;
    vcar:array[0..MAXN] of longint;
    vvar:array[1..MAXN] of extended;
    nume:array[1..MAXN] of string[10];
    i,j,k,m,n,p,vv,nf:longint;
    err:integer;
    s:string;
    ch,last:char;
    ok:boolean;
    vs,act,aux:extended;

procedure swaprows(ri,rj:integer);
begin
for i:=0 to n do
  begin
    vs:=eq[ri,i]; eq[ri,i]:=eq[rj,i]; eq[rj,i]:=vs;
    vs:=inv[ri,i]; inv[ri,i]:=inv[rj,i]; inv[rj,i]:=vs;
  end;
end;

procedure subtract(ri,rj:integer;mult:extended);
begin
for i:=1 to n do
  begin
    eq[ri,i]:=eq[ri,i]-eq[rj,i]*mult;
    inv[ri,i]:=inv[ri,i]-inv[rj,i]*mult;
  end;
end;

procedure gauss;
var row,col,l:integer;
    found:boolean;
begin
fillchar(inv,sizeof(inv),0);
for row:=1 to n do
  inv[row,row]:=1;

for row:=1 to n do
  begin
    if (abs(eq[row,row])<eps) then
      begin
        found:=false;

        if (not found) then
          begin
            writeln('BAD GAUSS!!');
            halt(0);
          end;

        for l:=row+1 to n do
          if (abs(eq[l,row])>eps) then
            begin
              found:=true;
              swaprows(row,l);
              break;
            end;
      end;

    { Divide entire row by eq[row,row] }
    vs:=eq[row,row];
    for i:=1 to n do
      begin
        eq[row,i]:=eq[row,i]/vs;
        inv[row,i]:=inv[row,i]/vs;
      end;

    for l:=row+1 to n do
      if (abs(eq[l,row])>eps) then
        begin
          subtract(l,row,eq[l,row]);
        end;
  end;

for row:=1 to n do
  for col:=row+1 to n do
    if (abs(eq[row,col])>eps) then
      begin
        subtract(row,col,eq[row,col]);
      end;
end;

procedure printsol;
begin
assign(output,'sol.out'); rewrite(output);

for i:=1 to n do
  begin
    vvar[i]:=0;
    for j:=1 to n do
      vvar[i]:=vvar[i]+inv[i,j]*(-eq[j,0]);

    vvar[i]:=trunc(vvar[i]*1e5)/1e5;
    writeln({nume[i],'=',}vvar[i]:0:8);
  end;
close(output);
end;

procedure eval;
begin
assign(output,''); rewrite(output);
ok:=true;
for k:=1 to 1 do
  begin
    vs:=eqini[k,0];
    for i:=1 to n do
      begin
        act:=eqini[k,i]*vvar[i];
        vs:=vs+act;
      end;

    if (abs(vs)>epsrez) then
      begin
        i:=k;
        ok:=false;
        break;
      end;
  end;

if (ok) then
  writeln('OK')
else
  writeln('WA ',i,' ',vs:0:13);
close(output);
end;

procedure get(mult:longint);
begin
repeat
  read(ch);
until (not(ch in term));

inc(nt[k]);
fillchar(vcar,sizeof(vcar),0);
vcar[0]:=mult;

last:='+'; s:='';
while (not(ch in term)) do
  begin
    if (ch='+') or (ch='-') then
      begin
        if (s<>'') then
          begin
            if (s[1] in digits) then
              begin
                { Numeric constant }
                val(s,vv,err);
                vcar[0]:=vcar[0]*vv;
              end
            else
              begin
                { Variable }
                i:=0;
                for j:=1 to n do
                  if (nume[j]=s) then
                    begin
                      i:=j; break;
                    end;

                if (i=0) then
                  begin
                    writeln('EROARE!');
                    halt(0);
                  end;

                vcar[i]:=vcar[i]+1;
              end;
            s:='';

            nf:=0;
            for j:=1 to n do
              if (vcar[j]>0) then
                begin
                  i:=j; nf:=nf+vcar[j];
                end;

            if (nf=0) then
              eq[k,0]:=eq[k,0]+vcar[0]
            else
            if (nf=setnum) and (vcar[i]=setnum) then
              eq[k,i]:=eq[k,i]+vcar[0]
            else
              begin
                writeln('EROARE!!!');
                halt(0);
              end;
            fillchar(vcar,sizeof(vcar),0);
          end;

        last:=ch;
        inc(nt[k]);
        vcar[0]:=mult;

        if (last='-') then
          vcar[0]:=-vcar[0];
      end
    else
    if (ch='*') then
      begin
        if (s<>'') then
          begin
            if (s[1] in digits) then
              begin
                { Numeric constant }
                val(s,vv,err);
                vcar[0]:=vcar[0]*vv;
              end
            else
              begin
                { Variable }
                i:=0;
                for j:=1 to n do
                  if (nume[j]=s) then
                    begin
                      i:=j; break;
                    end;

                if (i=0) then
                  begin
                    writeln('EROARE!');
                    halt(0);
                  end;

                vcar[i]:=vcar[i]+1;
              end;
            s:='';
          end;
      end
    else
      s:=s+ch;

    read(ch);
  end;

if (s<>'') then
  begin
    if (s[1] in digits) then
      begin
        { Numeric constant }
        val(s,vv,err);
        vcar[0]:=vcar[0]*vv;
      end
    else
      begin
        { Variable }
        i:=0;
        for j:=1 to n do
          if (nume[j]=s) then
            begin
              i:=j; break;
            end;

        if (i=0) then
          begin
            writeln('EROARE!');
            halt(0);
          end;

        vcar[i]:=vcar[i]+1;
      end;
    s:='';

    nf:=0;
    for j:=1 to n do
      if (vcar[j]>0) then
        begin
          i:=j; nf:=nf+vcar[j];
        end;

    if (nf=0) then
      eq[k,0]:=eq[k,0]+vcar[0]
    else
    if (nf=setnum) and (vcar[i]=setnum) then
      eq[k,i]:=eq[k,i]+vcar[0]
    else
      begin
        writeln('EROARE!!!');
        halt(0);
      end;

    fillchar(vcar,sizeof(vcar),0);
  end;
end;

begin
assign(input,'eq04.in'); reset(input);
readln(n);
for i:=1 to n do
  readln(nume[i]);
read(m);

fillchar(eq,sizeof(eq),0);
for k:=1 to m do
  begin
    get(1);
    get(-1);
  end;

move(eq,eqini,sizeof(eq));

gauss;
printsol;
eval;
end.