{$N+}
Program _SOLVE_LINEAR_EQS;

const term=['=',#13,#10];
      digits=['0'..'9'];
      eps:extended=1e-13;
      epsrez:extended=1e-8;
      MAXN=111;
      setnum=2;

var eq,eqini,a{,inv}:array[1..MAXN,0..MAXN] of extended;
    v,nt,max:array[1..MAXN] of longint;
    vcar:array[0..MAXN] of longint;
    vvar:array[1..MAXN] of extended;
    nume:array[1..MAXN] of string[10];
    i,j,k,m,n,p,vv,nf:longint;
    err:integer;
    s:string;
    ch,last:char;
    ok:boolean;
    vs,act,aux:extended;

procedure printsol;
begin
assign(output,'sol1.out'); rewrite(output);

for i:=1 to n do
  begin
    writeln(nume[i],'=',vvar[i]:0:8);
  end;
close(output);
end;

procedure eval;
begin
assign(output,''); rewrite(output);
ok:=true;
for k:=1 to m do
  begin
    vs:=eqini[k,0];
    for i:=1 to n do
      begin
        act:=eqini[k,i]*vvar[i];
        vs:=vs+act;
      end;

    if (abs(vs)>epsrez) then
      begin
        i:=k;
        ok:=false;
        break;
      end;
  end;

if (ok) then
  writeln('OK')
else
  writeln('WA ',i,' ',vs:0:13);
close(output);
end;

procedure get(mult:longint);
begin
repeat
  read(ch);
until (not(ch in term));

inc(nt[k]);
fillchar(vcar,sizeof(vcar),0);
vcar[0]:=mult;

last:='+'; s:='';
while (not(ch in term)) do
  begin
    if (ch='+') or (ch='-') then
      begin
        if (s<>'') then
          begin
            if (s[1] in digits) then
              begin
                { Numeric constant }
                val(s,vv,err);
                vcar[0]:=vcar[0]*vv;
              end
            else
              begin
                { Variable }
                i:=0;
                for j:=1 to n do
                  if (nume[j]=s) then
                    begin
                      i:=j; break;
                    end;

                if (i=0) then
                  begin
                    writeln('EROARE!');
                    halt(0);
                  end;

                vcar[i]:=vcar[i]+1;
              end;
            s:='';

            nf:=0;
            for j:=1 to n do
              if (vcar[j]>0) then
                begin
                  i:=j; nf:=nf+vcar[j];
                end;

            if (nf=0) then
              eq[k,0]:=eq[k,0]+vcar[0]
            else
            if (nf=setnum) and (vcar[i]=setnum) then
              eq[k,i]:=eq[k,i]+vcar[0]
            else
              begin
                writeln('EROARE!!!');
                halt(0);
              end;
            fillchar(vcar,sizeof(vcar),0);
          end;

        last:=ch;
        inc(nt[k]);
        vcar[0]:=mult;

        if (last='-') then
          vcar[0]:=-vcar[0];
      end
    else
    if (ch='*') then
      begin
        if (s<>'') then
          begin
            if (s[1] in digits) then
              begin
                { Numeric constant }
                val(s,vv,err);
                vcar[0]:=vcar[0]*vv;
              end
            else
              begin
                { Variable }
                i:=0;
                for j:=1 to n do
                  if (nume[j]=s) then
                    begin
                      i:=j; break;
                    end;

                if (i=0) then
                  begin
                    writeln('EROARE!');
                    halt(0);
                  end;

                vcar[i]:=vcar[i]+1;
              end;
            s:='';
          end;
      end
    else
      s:=s+ch;

    read(ch);
  end;

if (s<>'') then
  begin
    if (s[1] in digits) then
      begin
        { Numeric constant }
        val(s,vv,err);
        vcar[0]:=vcar[0]*vv;
      end
    else
      begin
        { Variable }
        i:=0;
        for j:=1 to n do
          if (nume[j]=s) then
            begin
              i:=j; break;
            end;

        if (i=0) then
          begin
            writeln('EROARE!');
            halt(0);
          end;

        vcar[i]:=vcar[i]+1;
      end;
    s:='';

    nf:=0;
    for j:=1 to n do
      if (vcar[j]>0) then
        begin
          i:=j; nf:=nf+vcar[j];
        end;

    if (nf=0) then
      eq[k,0]:=eq[k,0]+vcar[0]
    else
    if (nf=setnum) and (vcar[i]=setnum) then
      eq[k,i]:=eq[k,i]+vcar[0]
    else
      begin
        writeln('EROARE!!!');
        halt(0);
      end;

    fillchar(vcar,sizeof(vcar),0);
  end;
end;

begin
assign(input,'eq04.in'); reset(input);
readln(n);
for i:=1 to n do
  readln(nume[i]);
read(m);

fillchar(eq,sizeof(eq),0);
for k:=1 to m do
  begin
    get(1);
    get(-1);
  end;
move(eq,eqini,sizeof(eq));

for i:=1 to n do
  for j:=0 to n do
    a[1,j]:=-eq[1,j]/eq[1,1];
a[1,1]:=0;

for i:=2 to n do
  begin
    for j:=0 to n do
      a[i,j]:=-eq[i,j]/eq[i,i];

    a[i,i]:=0;
    for k:=1 to i-1 do
      begin
        for j:=0 to n do
          a[i,j]:=a[i,j]+a[i,k]*a[k,j];
        a[i,k]:=0;
      end;

    for j:=0 to n do
      if (j<>i) then
        a[i,j]:=a[i,j]/(1-a[i,i]);
    a[i,i]:=0;
  end;

vvar[n]:=a[n,0];
for i:=n-1 downto 1 do
  begin
    vvar[i]:=a[i,0];
    for j:=i+1 to n do
      vvar[i]:=vvar[i]+a[i,j]*vvar[j];
  end;

printsol;
eval;
end.