{
This is a demo for the CHESS.PAS Pascal unit.
It will not be used during the evaluation process.
The Black King moves randomly, but the moves are valid!
During the evaluation process another algorithm will be used for the Black King.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be slightly longer than the time needed for the
  execution of the functions and procedures in this unit!
This unit contains implementations of algorithms for determining legal
  moves, performing moves, detecting mate positions etc. You may copy
  these algorithms from this unit, but you are adviced to build your own
  algorithms (for efficiency reasons)!
The initial positions and the number of moves are read from the CHESS.IN
  file. You may edit your own CHESS.IN file in order to test your program!
  Your program must not try the open the CHESS.IN file for reading because
  this file will not exist during the evaluation. The unit used for
  evaluation will use a different method for getting the initial position
  and the number of moves!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Stuff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, November 5th, 2002!
}



unit chess;

interface

var columnBlackKing,columnWhiteKing,columnWhiteQueen:Char;
    lineBlackKing,lineWhiteKing,lineWhiteQueen:Integer;
    moves:Integer;
    table:array[1..8,'a'..'h'] of Integer;
    white:Boolean;
    nr:Integer;
    pozx:array[1..8] of Char;
    pozy:array[1..8] of Integer;
    initialized:Boolean;
    ss:string;
    f:text;

procedure Init;
function GetBlackKingPosition:String;
function GetWhiteKingPosition:String;
function GetWhiteQueenPosition:String;
function MovesLeft:Integer;
procedure MoveWhiteQueen(position:String);
procedure MoveWhiteKing(position:String);
procedure MoveBlackKing;

implementation

procedure error(s:string);
begin
  writeln(s);
  halt;
end;

procedure init;
begin
  if initialized then
    error('Game already initialized!');
  randomize;
  writeln('Game initialized!');
  assign(f,'CHESS.IN');
  reset(f);
  readln(f,columnBlackKing, lineBlackKing,
           columnWhiteKing, columnWhiteKing, lineWhiteKing,
	   columnWhiteQueen, columnWhiteQueen, lineWhiteQueen,
	   moves);
  close(f);
  initialized := true;
  white := true
end;

function GetBlackKingPosition:String;
begin
  if not initialized then
    error('Game not initialized!');
  ss := '  ';
  ss[1] := columnBlackKing;
  ss[2] := chr(lineBlackKing + ord('0'));
  writeln('Black King at ', ss);
  GetBlackKingPosition:=ss;
end;

function GetWhiteKingPosition:String;
begin
  if not initialized then
    error('Game not initialized!');
  ss := '  ';
  ss[1] := columnWhiteKing;
  ss[2] := chr(lineWhiteKing + ord('0'));
  writeln('White King at ', ss);
  GetWhiteKingPosition:=ss;
end;

function GetWhiteQueenPosition:String;
begin
  if not initialized then
    error('Game not initialized!');
  ss := '  ';
  ss[1] := columnWhiteQueen;
  ss[2] := chr(lineWhiteQueen + ord('0'));
  writeln('White Queen at ', ss);
  GetWhiteQueenPosition:=ss;
end;

function MovesLeft:Integer;
begin
  if not initialized then
    error('Game not initialized!');
  writeln(moves,' moves left!');
  MovesLeft := moves;
end;

procedure MakeBlackKingMove;
const dx:array[1..8] of integer=(1,1,1,0,-1,-1,-1,0);
      dy:array[1..8] of integer=(1,0,-1,-1,-1,0,1,1);
var y,yy,j,k:Integer;
    x,xx,i:char;
begin
  for i := 'a' to 'h' do
    for j := 1 to 8 do
     table[j][i] := 0;
  xx := columnBlackKing;
  yy := lineBlackKing;
  for k:=1 to 8 do
  begin
    x := chr(ord(xx)+dx[k]);
    y := yy + dy[k];
    if (x>='a') and (x<='h') and (y>=1) and (y<=8) then
      table[y][x] := 1;
  end;
  xx := columnWhiteKing;
  yy := lineWhiteKing;
  for k:=1 to 8 do
  begin
    x := chr(ord(xx)+dx[k]);
    y := yy + dy[k];
    if (x>='a') and (x<='h') and (y>=1) and (y<=8) then
      table[y][x] := 0;
  end;
  xx := columnWhiteQueen;
  yy := lineWhiteQueen;
  x := pred(xx);
  y := yy;
  while x>='a' do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := pred(x);
  end;
  x := succ(xx);
  y := yy;
  while x<='h' do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := succ(x);
  end;
  x := xx;
  y := yy - 1;
  while y>=1 do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    dec(y);
  end;
  x := xx;
  y := yy + 1;
  while y<=8 do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    inc(y);
  end;
  x := pred(xx);
  y := yy - 1;
  while (x>='a') and (y>=1) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := pred(x);
    dec(y);
  end;
  x := succ(xx);
  y := yy + 1;
  while (x<='h') and (y<=8) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := succ(x);
    inc(y);
  end;
  x := succ(xx);
  y := yy - 1;
  while (x<='h') and (y>=1) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := succ(x);
    dec(y);
  end;
  x := pred(xx);
  y := yy + 1;
  while (x>='a') and (y<=8) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    table[y][x] := 2;
    x := pred(x);
    inc(y);
  end;
  nr := 0;
  for i := 'a' to 'h' do
    for j := 1 to 8 do
     if table[j][i] = 1 then
     begin
       inc(nr);
       pozx[nr] := i;
       pozy[nr] := j;
     end;
end;

procedure MoveWhiteQueen(position:String);
var y,yy,j:Integer;
    x,xx,i:char;
begin
  if not initialized then
    error('Game not initialized!');
  if not white then
    error('White player moved twice!');
  if (position[1]<'a') or (position[1]>'h') or (position[2]<'1') or (position[2]>'8') then
    error('Illegal position!');
  for i := 'a' to 'h' do
    for j := 1 to 8 do
     table[j][i] := 0;
  xx := columnWhiteQueen;
  yy := lineWhiteQueen;
  x := pred(xx);
  y := yy;
  while x>='a' do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := pred(x);
  end;
  x := succ(xx);
  y := yy;
  while x<='h' do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := succ(x);
  end;
  x := xx;
  y := yy - 1;
  while y>=1 do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    dec(y);
  end;
  x := xx;
  y := yy + 1;
  while y<=8 do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    inc(y);
  end;
  x := pred(xx);
  y := yy - 1;
  while (x>='a') and (y>=1) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := pred(x);
    dec(y);
  end;
  x := succ(xx);
  y := yy + 1;
  while (x<='h') and (y<=8) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := succ(x);
    inc(y);
  end;
  x := succ(xx);
  y := yy - 1;
  while (x<='h') and (y>=1) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := succ(x);
    dec(y);
  end;
  x := pred(xx);
  y := yy + 1;
  while (x>='a') and (y<=8) do
  begin
    if (x=columnWhiteKing) and (y=lineWhiteKing) then
      break;
    if (x=columnBlackKing) and (y=lineBlackKing) then
    begin
      table[y][x] := 1;
      break;
    end;
    table[y][x] := 1;
    x := pred(x);
    inc(y);
  end;
  x := position[1];
  y := ord(position[2])-ord('0');
  if table[y][x] = 0 then
    error('Illegal move!');
  columnWhiteQueen := position[1];
  lineWhiteQueen := ord(position[2])-ord('0');
  writeln('White Queen moved to ',position);
  white := false;
  dec(moves);
  MakeBlackKingMove;
  if nr= 0 then
  begin
    x := columnBlackKing;
    y := lineBlackKing;
    if (table[y][x] = 2) then
      error('Check-mate! You win!')
    else
      error('Draw! Black King cannot move!');
  end;
  if moves = 0 then
    error('No more moves available!')
end;

procedure MoveWhiteKing(position:String);
const dx:array[1..8] of integer=(1,1,1,0,-1,-1,-1,0);
      dy:array[1..8] of integer=(1,0,-1,-1,-1,0,1,1);
var y,yy,j,k:Integer;
    x,xx,i:char;
begin
  if not initialized then
    error('Game not initialized!');
  if not white then
    error('White player moved twice!');
  if (position[1]<'a') or (position[1]>'h') or (position[2]<'1') or (position[2]>'8') then
    error('Illegal position!');
  for i := 'a' to 'h' do
    for j := 1 to 8 do
     table[j][i] := 0;
  xx := columnWhiteKing;
  yy := lineWhiteKing;
  for k:=1 to 8 do
  begin
    x := chr(ord(xx)+dx[k]);
    y := yy + dy[k];
    if (x>='a') and (x<='h') and (y>=1) and (y<=8) then
      table[y][x] := 1;
  end;
  xx := columnBlackKing;
  yy := lineBlackKing;
  for k:=1 to 8 do
  begin
    x := chr(ord(xx)+dx[k]);
    y := yy + dy[k];
    if (x>='a') and (x<='h') and (y>=1) and (y<=8) then
      table[y][x] := 0;
  end;
  xx := columnWhiteQueen;
  yy := lineWhiteQueen;
  table[yy][xx] := 0;
  x := position[1];
  y := ord(position[2])-ord('0');
  if table[y][x] = 0 then
    error('Illegal move!');
  columnWhiteKing := position[1];
  lineWhiteKing := ord(position[2])-ord('0');
  writeln('White King moved to ',position);
  white := false;
  dec(moves);
  MakeBlackKingMove;
  if nr = 0 then
    error('Draw! Black King cannot move!');
  if moves = 0 then
    error('No more moves available!')
end;

procedure MoveBlackKing;
var mutare:Integer;
begin
  if not initialized then
    error('Game not initialized!');
  if white then
    error('Black player asked to move twice!');
  mutare := random(nr) + 1;
  columnBlackKing := pozx[mutare];
  lineBlackKing := pozy[mutare];
  white := true;
  writeln('Black King moved!');
  if (columnBlackKing = columnWhiteQueen) and (lineBlackKing = lineWhiteQueen) then
    error('Draw! White Queen captured!');
end;

end.