{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
This is a demo for the GRAPH.PAS Pascal unit.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the unit used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions and procedures in the unit
  used for evaluation will be no longer than the time needed for the
  execution of the functions and procedures in this unit!
The unit uses the file GRAPH.TXT for initializing.You may edit your own GRAPH.TXT
  file in order to test your program! Your program must not try to open the
  GRAPH.TXT file for reading because this file will not exist during the evaluation.
  The unit used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Stuff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, December 3rd, 2002!
}
unit graph;

interface

procedure Init;
function GetNumberOfNodes:Integer;
function GetNumberOfCallsLeft:Integer;
function IsEdgeBetween(x,y:Integer):Boolean;
function CheckEdgeWeight(x,y,c:Integer):Boolean;
function GetNodeWeight(x:Integer):Longint;
procedure Result(x,y,c:Integer);

implementation

type IntegerArray=array[1..10000] of Integer;
     BooleanArray=array[1..10000] of Boolean;
     LongintArray=array[1..10000] of Longint;

var edges,costs:^IntegerArray;
    results:^BooleanArray;
    nodes:^LongintArray;
    numberOfNodes:Integer;
    callsLeft:Integer;
    numberOfResults:Integer;
    f:text;
    initialized:boolean;
    t:longint absolute $0:$046c;
    t1:longint;

procedure error(s:string);
begin
  writeln(s);
  writeln((t-t1)*0.055:0:2,' seconds...');
  halt;
end;

function GetNumberOfNodes:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetNumberOfNodes := numberOfNodes;
end;

function GetNumberOfCallsLeft:Integer;
begin
  if not initialized then
    error('Library not initialized!');
  GetNumberOfCallsLeft := callsLeft;
end;

function IsEdgeBetween(x,y:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if (x<1) or (x>numberOfNodes) or  (y<1) or (y>numberOfNodes) then
    error('The node does not exist!');
  IsEdgeBetween := (edges^[x] = y) or (edges^[y] = x);
end;

function GetNodeWeight(x:Integer):Longint;
begin
  if not initialized then
    error('Library not initialized!');
  if (x<1) or (x>numberOfNodes) then
    error('The node does not exist!');
  GetNodeWeight := nodes^[x];
end;

function CheckEdgeWeight(x,y,c:Integer):Boolean;
begin
  if not initialized then
    error('Library not initialized!');
  if callsLeft = 0 then
    error('Too many calls!');
  if (x<1) or (x>numberOfNodes) or  (y<1) or (y>numberOfNodes) then
    error('The node does not exist!');
  if edges^[x]=y then
    CheckEdgeWeight := costs^[x] = c
  else
    if edges^[y]=x then
      CheckEdgeWeight := costs^[y] = c
    else
      error('The edge does not exist!');
  dec(callsLeft);
end;

procedure Init;
var i,x,y,c:Integer;
begin
  t1 := t;
  if initialized then
    error('Library already initialized!');
  new(edges);
  new(costs);
  new(results);
  new(nodes);
  initialized := true;
  numberOfResults := 0;
  assign(f,'GRAPH.TXT');
  reset(f);
  readln(f,numberOfNodes);
  readln(f,callsLeft);
  for i:=1 to numberOfNodes do
  begin
    nodes^[i] := 1;
    edges^[i] := 0;
    costs^[i] := 0;
    results^[i] := false;
  end;
  for i:=1 to numberOfNodes do
  begin
    readln(f,x,y,c);
    nodes^[x] := nodes^[x] * c;
    nodes^[y] := nodes^[y] * c;
    if edges^[x]=0 then
    begin
      edges^[x] := y;
      costs^[x] := c;
    end
    else
    begin
      edges^[y] := x;
      costs^[y] := c;
    end;
  end;
  close(f);
end;

procedure Result(x, y, c:Integer);
begin
  if not initialized then
    error('Library already initialized!');
  if (x<1) or (x>numberOfNodes) or  (y<1) or (y>numberOfNodes) then
    error('The node does not exist!');
  if edges^[x] = y then
    if costs^[x] = c then
      if not results^[x] then
      begin
        results^[x] := true;
        inc(numberOfResults);
      end
      else
        error('Result submitted twice!')
    else
      error('Wrong result!')
  else
    if edges^[y] = x then
      if costs^[y] = c then
        if not results^[y] then
        begin
          results^[y] := true;
          inc(numberOfResults);
        end
        else
          error('Result submitted twice!')
      else
        error('Wrong result!')
    else
      error('The edge does not exist!');
  if numberOfResults = numberOfNodes then
    error('Ok!');
end;

end.