/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/*
   Pentru scrierea acestei solutii am folosit parti dintr-o
   implementare a algoritmului de sortare Ford-Johnson, gasita
   pe Internet
*/

#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sort.h"


long CompCount = 0, ncomp, nn, ii, res;

typedef struct ENTry {
      long Item;
      struct ENTry *Next;
      struct ENTry *Prev;
      struct ENTry *Up;
      struct ENTry *Down;
	} ENTRY;

ENTRY *aux;

class DLLIST {
 public:
   DLLIST ();
   ~DLLIST ();
   void MerInsSort ();
   void Insert (long Item);
   void Delete (long Item);
   long Count;
   ENTRY *Root;
   ENTRY *Tail;
 private:
   void MergeInsert (ENTRY **List, long Size);
   void PushDown (ENTRY *Top, ENTRY *Bott, ENTRY **BList,
		  ENTRY **AList);
   void BinInsert (ENTRY **AList, ENTRY *BList, long Size);
      };

DLLIST::DLLIST ()
{
 Root = NULL;
 Tail = NULL;
 Count = 0;
}

DLLIST::~DLLIST ()
{ENTRY *Curr = NULL;

 if (Root != NULL)
   Curr = Root->Next;
 else
   Curr = NULL;

 while (Curr != NULL) {
   free (Root);
   Root = Curr;
   Curr = Curr->Next;
 }

 if (Root != NULL)
   free (Root);

}

void DLLIST::Insert (long Item)
{ENTRY *NEnt = NULL;

 Count++;
 NEnt = (ENTRY *) malloc (sizeof (ENTRY));
 if (NEnt == NULL) {
   fprintf (stderr,"malloc () failed!!!\n");
   exit (-1);
 }
 NEnt->Item = Item;
 NEnt->Next = NULL;
 NEnt->Prev = NULL;
 NEnt->Up = NULL;
 NEnt->Down = NULL;
 if (Root == NULL) {
   Root = NEnt;
   Tail = NEnt;
 }
 else {
     Tail->Next = NEnt;
     NEnt->Prev = Tail;
     Tail = NEnt;
 }
}

void DLLIST::Delete (long Item)
{ENTRY *Curr = NULL;

 Curr = Root;
 while ((Curr != NULL) && (Curr->Item != Item))
   Curr = Curr->Next;

 if (Curr->Item == Item) {
   Count--;
   if (Curr == Root)
     Root = Root->Next;
   else if (Curr == Tail)
     Tail = Tail->Prev;
   else {
     Curr->Prev->Next = Curr->Next;
     Curr->Next->Prev = Curr->Prev;
   }
   free (Curr);
 }

}

void DLLIST::MerInsSort ()
{ENTRY *Start = NULL;

 Start = Root;
 MergeInsert (&Start, Count);
 Root = Start;
}

void DLLIST::MergeInsert (ENTRY **List, long Size)
{ENTRY *BList = NULL,
       *Curr = NULL,
       *Tmp = NULL;
 long Idx,
     OSize,
     TSize;

 if (Size == 1)
   return ;

 OSize = Size;
 Curr = *List;
 TSize = Size / 2;
 for (Idx = 0; Idx < TSize; Idx++) {
   Tmp = Curr->Next->Next;
   Size--;
   CompCount++;
   ncomp=GetNoComp();

   if (ncomp>0)
     res=IsGreater(Curr->Item , Curr->Next->Item);
   else
     res=1;

   if (res)
     PushDown (Curr, Curr->Next, &BList, List);
   else
     PushDown (Curr->Next, Curr, &BList, List);

   Curr = Tmp;
 }

 if ((OSize % 2) == 1) {
   Curr = (*List);
   while (Curr->Next != NULL)
     Curr = Curr->Next;
   Curr->Prev->Next = NULL;
   BList->Prev = Curr;
   Curr->Next = BList;
   BList = Curr;
   BList->Prev = NULL;
   BList->Up = NULL;
   BList->Down = NULL;
   Size--;
 }

 MergeInsert (List, Size);
 BinInsert (List, BList, Size);
}

void DLLIST::PushDown (ENTRY *Top, ENTRY *Bott, ENTRY **BList, ENTRY **AList)
{
 if (Bott == (*AList))
   *AList = (*AList)->Next;
 
 if (Bott->Next == Top) {
   Top->Prev = Bott->Prev;
   if (Bott->Prev != NULL)
     Bott->Prev->Next = Top;  
 }
 else {
   Top->Next = Bott->Next;
   if (Top->Next != NULL)
     Top->Next->Prev = Bott->Prev;
 }

 Bott->Next = *BList;
 Bott->Prev = NULL;
 Bott->Up = Top;
 Bott->Down = NULL;
 *BList = Bott;
}

long BuildBList (ENTRY **AList, ENTRY **BList, long &Size)
{long BCnt = 0;
 ENTRY *Curr = NULL,
       *Odd = NULL,
       *Itm = NULL;

 Curr = (*BList);
 Odd = NULL;
 while (Curr != NULL) {
  if (Curr->Up != NULL)
    Curr->Up->Down = Curr;
  else
    Odd = Curr;
  Curr = Curr->Next;
 }

 Curr = (*AList)->Next;
 if ((*AList)->Down != NULL) {
   (*AList)->Down->Next = (*AList);
   (*AList)->Prev = (*AList)->Down;
   (*AList) = (*AList)->Down;
   (*AList)->Next->Down = NULL;
   (*AList)->Prev = NULL;
   (*AList)->Up = NULL;
   Size++;
 }

 (*BList) = NULL;
 Itm = NULL;
 Curr = (*AList);
 while (Curr != NULL) {
   if (Curr->Down != NULL) {
     BCnt++;
     if ((*BList) == NULL) {
       Itm = (*BList) = Curr->Down;
       Itm->Prev = NULL;
       Itm->Next = NULL;
       Curr->Down = NULL;
     }
     else {
       Itm->Next = Curr->Down;
       Itm->Next->Next = NULL;
       Itm->Next->Prev = Itm;
       Curr->Down = NULL;
       Itm = Itm->Next;
     }
   }
   Curr = Curr->Next;
 }

 if (Odd != NULL) {
   if ((*BList) == NULL) {
      Odd->Next = NULL;
      Odd->Prev = NULL;
      Odd->Up = NULL;
     (*BList) = Odd;
     return 1;
   }

   Itm = (*BList);
   while (Itm->Next != NULL)
     Itm = Itm->Next;
   Itm->Next = Odd;
   Odd->Prev = Itm;
   Odd->Next = NULL;
   BCnt++;
   Odd->Up = NULL;
   Odd->Down = NULL;
 }

 return BCnt;
}

void ReInsert (ENTRY **AList, ENTRY *Curr, ENTRY *Itm, long &Size)
{
 if (Curr == NULL) {
   CompCount++;
   ncomp=GetNoComp();
   if (ncomp>0)
     res=IsGreater((*AList)->Item , Itm->Item);
   else
     res=1;

   if (res) {
     (*AList)->Prev = Itm;
     Itm->Next = (*AList);
     Itm->Prev = NULL;
     Itm->Up = NULL;
     (*AList) = Itm;
   }
   else {
     Curr = (*AList);
     while (Curr->Next != NULL)
       Curr = Curr->Next;
     Curr->Next = Itm;
     Itm->Prev = Curr;
     Itm->Next = NULL;
     Itm->Up = NULL;
   }
 }
 else {
   CompCount++;
   ncomp=GetNoComp();
   if (ncomp>0)
     res=IsGreater(Itm->Item , Curr->Item);
   else
     res=1;

   if (res) {
     Itm->Next = Curr->Next;
     Itm->Prev = Curr;
     Itm->Up = NULL;
     if (Curr->Next)
       Curr->Next->Prev = Itm;
     Curr->Next = Itm;
   }
   else {
     Itm->Next = Curr;
     Itm->Prev = Curr->Prev;
     Itm->Up = NULL;
     if (Curr->Prev)
       Curr->Prev->Next = Itm;
     Curr->Prev = Itm;
     if (Curr == (*AList))
       (*AList) = Itm;
   }
 }
 Size++;

}

ENTRY *SelectB (ENTRY **BList, long &Idx, long &Done)
{ENTRY *Curr = NULL,
       *Itm = NULL;
 long   Loc;

 Curr = (*BList);
 for (Loc = 2; Loc < Idx; Loc++)
   if (Curr->Next != NULL)
     Curr = Curr->Next;
   else {
     Idx = Idx - (Idx - Loc);
     Done = 1;
     break;
   }

 Itm = (ENTRY *) malloc (sizeof (ENTRY));
 if (Itm == NULL) {
   fprintf (stderr,"malloc () failed!!!\n");
   exit (-1);
 }

 Itm->Item = Curr->Item;
 Itm->Next = Curr->Next;
 Itm->Prev = Curr->Prev;
 if (Curr->Prev != NULL)
   Curr->Prev->Next = Itm;
 if (Curr->Next != NULL)
   Curr->Next->Prev = Itm;
 if (Curr == (*BList))
   (*BList) = Itm;
 Itm->Up = Curr->Up;
 Itm->Down = NULL;

 Itm = Curr;

 return Itm;
}

void DLLIST::BinInsert (ENTRY **AList, ENTRY *BList, long Size)
{long k, Val,
     Loc, Idx,
     BCnt,
     Low, High, Mid,
     Done = 0,
     PIdx = 2;
 ENTRY *Curr = NULL,
       *Itm = NULL;

 BCnt = BuildBList (AList, &BList, Size);

 if (BCnt == 0)
   return;

 for (k = 2; k <= Size; k++) {
   if ((Done) || (BCnt == 0))
     break;

   Idx = (((long int) ((pow (2, (k+1))) + (pow (-1, k)))) / 3);
   Val = Idx;
   while (PIdx <= Idx) {
     Itm = SelectB (&BList, Idx, Done); 

     Curr = (*AList);
     Low = 1;
     High = 0;
     while (Curr != Itm->Up) {
       High++;
       Curr = Curr->Next;
     }
     Mid = (Low + High) / 2;
     Curr = (*AList);

     if (Mid >= 2)
       for (Loc = 1; Loc < Mid; Loc++)
	 Curr = Curr->Next;

     while (Low < High) {
       if (Curr == NULL)
	 break;

       CompCount++;
       ncomp=GetNoComp();
       if (ncomp>0)
	 res=IsGreater(Itm->Item , Curr->Item);
       else
	 res=1;

       if (res) {
	 if ((Mid == Low) || (High == Mid)) {
	   Curr = Curr->Next;
	   Low = High;
	 }
	 else {
	   Low = Mid + 1;
	   Mid = (Low + High) / 2;
	   Curr = (*AList);
	   if (Mid >= 2)
	     for (Loc = 1; Loc < Mid; Loc++)
	       Curr = Curr->Next;
	 }
       }
       else {
	 if ((Mid == Low) || (High == Mid)) {
	   Curr = Curr->Prev;
	   Low = High;
	 }
	 else {
	   High = Mid - 1;
	   Mid = (Low + High) / 2;
	   Curr = (*AList);
	   if (Mid >= 2)
	     for (Loc = 1; Loc < Mid; Loc++)
	       Curr = Curr->Next;
	 }
       }
     }
     ReInsert (AList, Curr, Itm, Size);
     BCnt--;
     if (BCnt == 0)
       break;
     Idx--;
   }
   PIdx = Val + 1;
 }

 Curr = BList;
 while (Curr != NULL) {
   Itm = Curr->Next;
   free (Curr);
   Curr = Itm;
 }

}

int main ()
{
 DLLIST List;
 Init();
 nn = GetN();
 for (ii=nn;ii>=1;ii--)
   List.Insert(ii);

 List.MerInsSort ();

 for (ii=1,aux=List.Root;ii<=nn;ii++,aux=aux->Next)
   Result(ii,aux->Item);

 return 0;
}
