/*
This is a demo for the ARROWS.H C/C++ header.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the header used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions in the header
  used for evaluation will be no longer than the time needed for the
  execution of the functions in this header!
The header uses the file ARROWS.TXT for initializing. You may edit your own 
  ARROWS.TXT  file in order to test your program! Your program must not try 
  to open the ARROWS.TXT file for reading because this file will not exist 
  during the evaluation. The header used for evaluation will use a different 
  method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, March 11th, 2003!
*/

#include <stdio.h>
#include <stdlib.h>

int a[101][101];
int _N_,Rez,Nr;
int _initialized_;

void Evaluate(char *s){
  puts(s);
  exit(0);
}

void Init(void){
  FILE *f;
  int i,j;
  if (_initialized_)
    Evaluate("Library initialized twice!");
  _initialized_ = 1;
  f=fopen("ARROWS.TXT","rt");
  fscanf(f,"%d%d",&_N_,&Rez);
  Nr = _N_ << 1;
  for (i=1;i<=_N_;i++)
    for (j=1;j<=_N_;j++)
      fscanf(f,"%d",&a[i][j]);
  fclose(f);
}

int GetN(void){
  if (!_initialized_)
    Evaluate("Library not initialized!");
  return _N_;
}

int IsArrow(int x, int y){
  if (!_initialized_)
    Evaluate("Library not initialized!");
  Nr--;
  if (Nr < 0)
    Evaluate("Too many calls!");
  if (x < 1 || x > _N_ || y < 1 || y > _N_)
    Evaluate("Invalid circle!");
  return a[x][y];
}

void Result(int rez){
  if (!_initialized_)
    Evaluate("Library not initialized!");
  if (rez == Rez)
    Evaluate("Ok!");
  else
    Evaluate("Wrong answer!");
}