/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <math.h>
#include <string.h>
#define maxn 1010
#define filein "homm.in"
#define fileout "homm.out"

double x[maxn],y[maxn],l,eps=1e-7,a,b,c,d;
long stack[maxn],o[maxn],oaux[maxn],inside[maxn];
long nfence,smn,i,j,k,m,n,p,left;

double dist2d(double xa,double ya,double xb,double yb)
{
return sqrt((xa-xb)*(xa-xb)+(ya-yb)*(ya-yb));
}

long semn(double a,double b,double c,double x,double y)
{
double r=a*x+b*y+c;

if (fabs(r)<eps) return 0;
else
  if (r>0) return 1;
else
  return -1;
}

void sort(long li,long ls)
{
if (ls-li==1)
  {
  if (x[o[li]]>x[o[ls]] ||
     (x[o[li]]==x[o[ls]] && y[o[li]]>y[o[ls]]))
    {
    p=o[li]; o[li]=o[ls]; o[ls]=p;
    }
  }
else
if (ls-li>1)
  {
  sort(li,(li+ls)>>1);
  sort(((li+ls)>>1)+1,ls);

  k=li-1;
  i=li;
  m=(li+ls)>>1;
  j=m+1;

  while (i<=m && j<=ls)
    {
    k++;

    if (x[o[i]]<x[o[j]] ||
       (x[o[i]]==x[o[j]] && y[o[i]]<y[o[j]]))
      {
      oaux[k]=o[i];
      i++;
      }
    else
      {
      oaux[k]=o[j];
      j++;
      }
    }

  if (i<=m)
    {
    for (j=i;j<=m;j++)
      {
      k++;
      oaux[k]=o[j];
      }
    }
  else
    {
    for (i=j;i<=ls;i++)
      {
      k++;
      oaux[k]=o[i];
      }
    }

  for (k=li;k<=ls;k++)
    o[k]=oaux[k];
  }
}

int main()
{
freopen(filein,"r",stdin);
freopen(fileout,"w",stdout);

scanf("%ld",&n);

for (i=1;i<=n;i++)
  {
  scanf("%lf %lf",&x[i],&y[i]);
  o[i]=i;
  }

sort(1,n);

memset(inside,0,sizeof(inside));
nfence=1; left=n;

while (left>=3)
  {
  /* Compute convex hull */
  m=0; i=1;
  while (m<2)
    {
    if (!inside[o[i]])
      {
      m++;
      stack[m]=i;
      }

    i++;
    }
  inside[o[stack[2]]]=nfence;

  i=2;
  /* Step 1 */
  for (p=stack[2]+1;p<=n;p++)
    if (!inside[o[p]])
      {
      smn=-1;
      while (smn<0)
	{
	if (i==1)
	  {
	  i++;
	  stack[i]=p;
	  inside[o[p]]=nfence;
	  smn=0;
	  }
	else
	  {
	  a=y[o[stack[i-1]]]-y[o[stack[i]]];
	  b=x[o[stack[i]]]-x[o[stack[i-1]]];
	  c=x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

	  smn=semn(a,b,c,x[o[p]],y[o[p]]);
	  if (smn>=0)
	    {
	    i++;
	    stack[i]=p;
	    inside[o[p]]=nfence;
	    }
	  else
	    {
	    inside[o[stack[i]]]=0;
	    i--;
	    }
	  }
	}
      }

  /* Step 2 */
  for (p=n;p>=1;p--)
    if (!inside[o[p]])
      {
      smn=-1;
      while (smn<0)
	{
	if (i==1)
	  {
	  i++;
	  stack[i]=p;
	  inside[o[p]]=nfence;
	  smn=0;
	  }
	else
	  {
	  a=y[o[stack[i-1]]]-y[o[stack[i]]];
	  b=x[o[stack[i]]]-x[o[stack[i-1]]];
	  c=x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

	  smn=semn(a,b,c,x[o[p]],y[o[p]]);
	  if (smn>=0)
	    {
	    i++;
	    stack[i]=p;
	    inside[o[p]]=nfence;
	    }
	  else
	    {
	    inside[o[stack[i]]]=0;
	    i--;
	    }
	  }
	}
      }

  nfence++;
  for (left=0,i=1;i<=n;i++)
    if (!inside[i]) left++;
  }

for (i=1;i<=n;i++)
  {
  if (inside[i]==0)
    inside[i]=nfence;

  printf("%ld\n",inside[i]);
  }

return 0;
}