/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* A greedy algorithm (obviously not optimal) */

/* Time Complexity: O(N^3) , considering that only O(N^2) goals were scored */

/* - varianta 2 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define maxn 101
#define filein "football.in"
#define fileout "football.out"

int wins[maxn],draws[maxn],loses[maxn],ow[maxn],ol[maxn];
int gsco[maxn],grec[maxn],score[maxn][maxn];
int win[maxn][maxn],i,j,k,m,n,p,q,ok,i1,j1;

int main()
{
freopen(filein,"r",stdin);
scanf("%d",&n);
for (i=1;i<=n;i++)
  {
  scanf("%d %d %d %d %d",&wins[i],&draws[i],&loses[i],&gsco[i],&grec[i]);
  ow[i]=ol[i]=i;
  }

/* Sort the teams in decreasing order of the number of matches won */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((wins[ow[i]]<wins[ow[j]]) ||
	(wins[ow[i]]==wins[ow[j]] && loses[ow[i]]<loses[ow[j]]))
      {
      k=ow[i]; ow[i]=ow[j]; ow[j]=k;
      }

/* Sort the teams in decreasing order of the number of matches lost */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((loses[ol[i]]<loses[ol[j]]) ||
	(loses[ol[i]]==loses[ol[j]] && wins[ol[i]]>wins[ol[j]]))
      {
      k=ol[i]; ol[i]=ol[j]; ol[j]=k;
      }

/* Establish the outcome of every match: victory, draw or loss */
memset(win,0,sizeof(win));
for (p=ok=1;ok;)
  {
  ok=j=0;

  while (p<=n && !ok)
    {
    i=ow[p];
    for (q=1;q<=n && wins[i]>0;q++)
      if (i!=ol[q] && win[i][ol[q]]==0 && loses[ol[q]]>0)
	{
	j=ol[q];
	win[i][j]=1;
	win[j][i]=-1;
	wins[i]--; loses[j]--;
	ok=1; i=p; j=q; break;
	}

    if (!ok) p++;
    }

  if (ok)
    {
    /* Re-sort the teams in decreasing order of the number of matches won */
    while (i<n && wins[ow[i]]<wins[ow[i+1]])
      {
      /* Swap the positions i and i+1 */
      k=ow[i]; ow[i]=ow[i+1]; ow[i+1]=k;
      i++;
      }

    /* Sort the teams in decreasing order of the number of matches lost */
    while (j<n && loses[ol[j]]<loses[ol[j+1]])
      {
      /* Swap the positions j and j+1 */
      k=ol[j]; ol[j]=ol[j+1]; ol[j+1]=k;
      j++;
      }
    }
  }

/* Set the scores for every match */
memset(score,0,sizeof(score));

/* First, set all victories to a score of 1:0 and all draws to a score of 0:0 */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if (win[i][j]==1)
      score[i][j]=1,gsco[i]--,grec[j]--;
    else
    if (win[i][j]==-1)
      score[j][i]=1,gsco[j]--,grec[i]--;

/*
   Next, increase the scores in every match, until every team
   has scored & received the given amount of goals
*/

/* Sort the teams in decreasing order of the number of goals left to score */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((gsco[ow[i]]<gsco[ow[j]]) ||
	(gsco[ow[i]]==gsco[ow[j]] && grec[ow[i]]<grec[ow[j]]))
      {
      k=ow[i]; ow[i]=ow[j]; ow[j]=k;
      }

/* Sort the teams in decreasing order of the number of goals left to receive */
for (i=1;i<n;i++)
  for (j=i+1;j<=n;j++)
    if ((grec[ol[i]]<grec[ol[j]]) ||
	(grec[ol[i]]==grec[ol[j]] && gsco[ol[i]]>gsco[ol[j]]))
      {
      k=ol[i]; ol[i]=ol[j]; ol[j]=k;
      }


for (ok=p=1;ok;)
  {
  ok=j=0;

  while (p<=n && !ok)
    {
    i=ow[p];
    for (q=1;q<=n && gsco[i]>0;q++)
      if (ol[q]!=i && grec[ol[q]]>0)
	{
	j=ol[q];

	if (win[i][j]==1)
	  {
	  /* i wins */
	  if (score[i][j]<10)
	    {
	    score[i][j]++;
	    gsco[i]--;
	    grec[j]--;
	    ok=1; break;
	    }
	  }
	else
	if (win[j][i]==1)
	  {
	  /* j wins */
	  if (score[j][i]-score[i][j]>1 && score[i][j]<10)
	    {
	    score[i][j]++;
	    gsco[i]--;
	    grec[j]--;
	    ok=1; break;
	    }
	  }
	else
	  {
	  /* it's a draw */
	  if (gsco[j]>0 && grec[i]>0 && score[i][j]<10)
	    {
	    score[i][j]++;
	    score[j][i]++;
	    gsco[i]--; gsco[j]--;
	    grec[i]--; grec[j]--;
	    ok=1; break;
	    }
	  }
	}

    if (!ok) p++;
    }

  if (ok)
    {
    /* Re-sort the teams in decreasing order of the number of goals left to score */
    for (k=1;k<=n;k++)
      if (ow[k]==i) i1=k;
      else
      if (ow[k]==j) j1=k;

    if (j1>i1)
      {
      while (j1<n && gsco[ow[j1]]<gsco[ow[j1+1]])
	{
	/* Swap the positions j1 and j1+1 */
	k=ow[j1]; ow[j1]=ow[j1+1]; ow[j1+1]=k;
	j1++;
	}

      while (i1<n && gsco[ow[i1]]<gsco[ow[i1+1]])
	{
	/* Swap the positions i1 and i1+1 */
	k=ow[i1]; ow[i1]=ow[i1+1]; ow[i1+1]=k;
	i1++;
	}
      }
    else
      {
      while (i1<n && gsco[ow[i1]]<gsco[ow[i1+1]])
	{
	/* Swap the positions i1 and i1+1 */
	k=ow[i1]; ow[i1]=ow[i1+1]; ow[i1+1]=k;
	i1++;
	}

      while (j1<n && gsco[ow[j1]]<gsco[ow[j1+1]])
	{
	/* Swap the positions j1 and j1+1 */
	k=ow[j1]; ow[j1]=ow[j1+1]; ow[j1+1]=k;
	j1++;
	}
      }

    /* Re-sort the teams in decreasing order of the number of goals left to receive */
    for (k=1;k<=n;k++)
      if (ol[k]==i) i1=k;
      else
      if (ol[k]==j) j1=k;

    if (j1>i1)
      {
      while (j1<n && grec[ol[j1]]<grec[ol[j1+1]])
	{
	/* Swap the positions j1 and j1+1 */
	k=ol[j1]; ol[j1]=ol[j1+1]; ol[j1+1]=k;
	j1++;
	}

      while (i1<n && grec[ol[i1]]<grec[ol[i1+1]])
	{
	/* Swap the positions i1 and i1+1 */
	k=ol[i1]; ol[i1]=ol[i1+1]; ol[i1+1]=k;
	i1++;
	}
      }
    else
      {
      while (i1<n && grec[ol[i1]]<grec[ol[i1+1]])
	{
	/* Swap the positions i1 and i1+1 */
	k=ol[i1]; ol[i1]=ol[i1+1]; ol[i1+1]=k;
	i1++;
	}

      while (j1<n && grec[ol[j1]]<grec[ol[j1+1]])
	{
	/* Swap the positions j1 and j1+1 */
	k=ol[j1]; ol[j1]=ol[j1+1]; ol[j1+1]=k;
	j1++;
	}
      }
    }
  }

/* Output the SCORE matrix */
freopen(fileout,"w",stdout);
for (i=1;i<=n;i++)
  {
  printf("%d",score[i][1]);
  for (j=2;j<=n;j++)
    printf(" %d",score[i][j]);
  printf("\n");
  }

return 0;
}