/*
This is a demo for the MAX.H C/C++ header.
It will not be used during the evaluation process.
Please do not use in your program the variables defined in this file!
  The variables in the header used during the evaluation process have
  different identifiers, so your source might not be compiled correctly!
The time needed for the execution of the functions in the header
  used for evaluation will be no longer than the time needed for the
  execution of the functions in this header!
The header uses the file MAX.TXT for initializing. You may edit your own MAX.TXT
  file in order to test your program! Your program must not try to open the
  MAX.TXT file for reading because this file will not exist during the evaluation.
  The header used for evaluation will use a different method for getting the initial data!
This file is freeware. It cannot be modified, but can be distributed freely.
This file is distributed as-done.
The GInfo Editorial Staff is not responsible
  for any damage caused by the use of this file!
Author: Mihai Scortaru
Please report any bugs found in this file not later than
  Tuesday, January 22nd, 2003!
*/

#include <stdio.h>
#include <stdlib.h>
int a[256],N,noResults,callsLeft,initialized,m1,m2,m3,ok1,ok2,ok3;
FILE *f;

void error(char *s){
  puts(s);
  exit(0);
}

void Init(){
int i;
   if (initialized)
    error("Library already initialized!");
  initialized = 1;
  noResults = 0;
  f = fopen("MAX.TXT","rt");
  fscanf(f,"%d%d",&N,&callsLeft);
  for (i=1;i<=N;i++)   fscanf(f,"%d",&a[i]);
  fscanf(f,"%d%d%d",&m1,&m2,&m3);
  fclose(f);
}

int GetN(){
  if (!initialized)
    error("Library not initialized!");
  return N;
}

int GetNoComp(){
  if (!initialized)
    error("Library not initialized!");
  return callsLeft;
}

int IsGreater(int i, int j){
  if (!initialized)
    error("Library not initialized!");
  if (i<1 || i>N || j<1 || j>N)
    error("Invalid element!");
  if (!callsLeft)
    error("Too many calls!");
  callsLeft--;

  return a[i]>a[j];
}

void Max1(int x){
  if (!initialized)
    error("Library not initialized!");
  if ((x<1) || (x>N))
    error("Invalid element!");
  if (x!=m1)
    error("Wrong answer!");
  if (ok1)
    error("Result submitted twice!");
  ok1 = 1;
}

void Max2(int x){
  if (!initialized)
    error("Library not initialized!");
  if ((x<1) || (x>N))
    error("Invalid element!");
  if (x!=m2)
    error("Wrong answer!");
  if (ok2)
    error("Result submitted twice!");
  ok2 = 1;
}

void Max3(int x){
  if (!initialized)
    error("Library not initialized!");
  if ((x<1) || (x>N))
    error("Invalid element!");
  if (x!=m3)
    error("Wrong answer!");
  if (ok3)
    error("Result submitted twice!");
  ok3 = 1;
}

void EndProgram(){
  if (ok1 && ok2 && ok3)
    error("Ok!");
  else
    error("Not all results were submitted!");
}
