{$R-,I-,S-,Q-}
{$M 65000, 0, 655360}

Program _DWARFS_;

const filein = 'DWARFS.IN';
      fileout = 'DWARFS.OUT';
      MAXN = 25;
      MAXC = 300;
      infinit = 10000;
      dl : array [1..4] of integer = (-1, 0, +1, 0);
      dc : array [1..4] of integer = (0, +1, 0, -1);

type linie = array [1..MAXC] of integer;
     plinie = ^linie;

var map : array[0..MAXN, 1..MAXN] of integer;
    d : array[1..MAXC] of plinie;
    di : array[1..MAXC] of integer;
    sel : array[1..MAXC] of boolean;
    i, j, k, m, n, lmin, ncomp, lnext, cnext, last, cont, linked : integer;
    ch : char;

procedure fill(lin, col : integer);
var k : integer;
begin
if (map[lin][col] <> 0) then
  exit;

map[lin][col] := ncomp;

for k := 1 to 4 do
  begin
    lnext := lin+dl[k];
    cnext := col+dc[k];

    if (lnext >= 0) and (lnext <= m) and
       (cnext >= 1) and (cnext <= n) then
      fill(lnext, cnext);
  end;
end;

begin
{ read input data }
assign(input, filein);
reset(input);
read(m, n);
for i:= 1 to m do
  begin
    for j := 1 to n do
      begin
        ch := #0;
        repeat
          read(ch);
        until (ch = '0') or (ch = '1');

        if (ch = '0') then
          map[i][j] := 0
        else
          map[i][j] := -1;
      end;
  end;

{ do the fill }
for j := 1 to n do
  map[0][j] := 0;

ncomp := 0;
for i := 0 to m do
  for j := 1 to n do
    if (map[i][j] = 0) then
      begin
        ncomp := ncomp + 1;
        fill(i, j);
      end;


{ do a MST }
for i := 1 to ncomp do
  begin
    new(d[i]);
    for j := 1 to ncomp do
      d[i]^[j] := infinit;
  end;

for j := 1 to n do
  begin
    last := -1;
    cont := 0;

    for i := 0 to m do
      if (map[i][j] > 0) then
        begin
          if (last > -1) then
            begin
              if (d[last]^[map[i][j]] > cont) then
                begin
                  d[last]^[map[i][j]] := cont;
                  {
                  d[map[i][j]]^[last] := cont;
                  }
                end;
            end;

          last := map[i][j];
          cont := 0;
        end
      else
        cont := cont+1;
  end;

linked := 1;

fillchar(sel, sizeof(sel), false);
for i := 1 to ncomp do
  di[i] := infinit;

di[1] := 0;
sel[1] := true;
last := 1;
lmin := 0;
while (linked < ncomp) do
  begin
    for i := 1 to ncomp do
      if (not sel[i]) and (d[last]^[i] < di[i]) then
        di[i] := d[last]^[i];

    cont := infinit;
    for i := 1 to ncomp do
      if (not sel[i]) and (di[i] < cont) then
        begin
          last := i;
          cont := di[i];
        end;

    sel[last] := true;
    lmin := lmin + cont;

    linked := linked+1;
  end;

{ write output data }
assign(output, fileout);
rewrite(output);
writeln(lmin);
close(output);
end.