/* Time Complexity: O(N*logN + N) */

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#define filein "ARENA.IN"
#define fileout "ARENA.OUT"
#define maxn 5010
#define maxdim 9901
#define eps 1e-6

typedef struct nod { char nume[30]; int num; nod *urm; } NOD;

NOD *hash[maxdim], *aux;
double far *x, far *y;
int far *race, far *inside, far *oaux;
int stack[maxn], o[maxn];
int smn, i, j, k, m, n, N, p, li, ls, hc, nraces, worstrace;
double a, b, c, d, dnew, dmax, dmaxmax;
char nume[30];

int hashcode(const char* s)
{
long res;
int i, l;

for (l = strlen(s), res = i = 0; i < l; i++)
  res = ((res << 5) + s[i]) % maxdim;

return (int)res;
}

double dist2d(double xa, double ya, double xb, double yb)
{
return (xa-xb)*(xa-xb)+(ya-yb)*(ya-yb);
}

int semn(double a, double b, double c, double x, double y)
{
double r = a*x + b*y + c;

if (fabs(r) < eps) return 0;
else
  if (r > 0) return 1;
else
  return -1;
}

void sort(int li, int ls)
{
if (ls > li)
  {
    sort(li, (li+ls)>>1);
    sort(((li+ls)>>1)+1, ls);

    k = li-1;
    i = li;
    m = (li+ls)>>1;
    j = m+1;

    while (i <= m && j <= ls)
      {
        k++;

        if (race[o[i]] < race[o[j]] ||
           (race[o[i]] == race[o[j]] && x[o[i]] < x[o[j]]) ||
           (race[o[i]] == race[o[j]] && x[o[i]] == x[o[j]] && y[o[i]] < y[o[j]]))
          {
            oaux[k]=o[i];
            i++;
          }
        else
          {
            oaux[k]=o[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            oaux[k] = o[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            oaux[k] = o[i];
          }
      }

    for (k = li; k <= ls; k++)
      o[k] = oaux[k];
  }
}

int main()
{
double xaux, yaux;
/* init stuff */
x = (double *) malloc((maxn)*sizeof(double));
y = (double *) malloc((maxn)*sizeof(double));
race = (int *) malloc((maxn)*sizeof(int));
inside = (int *) malloc((maxn)*sizeof(int));
oaux = (int *) malloc((maxn)*sizeof(int));

/*
if (!x || !y || !race || !inside || !oaux)
  {
    printf("Not enough memory\n");
    exit(0);
  }
*/

for (i = 0; i < maxdim; i++)
  hash[i] = NULL;

/* input data */
freopen(filein, "r", stdin);

scanf("%d", &n);
for (nraces = 0, i = 1; i <= n; i++)
  {
    scanf("%lf %lf %[^\n]", &xaux, &yaux, &nume);
    x[i] = xaux;
    y[i] = yaux;
    o[i] = i;

    hc = hashcode(nume);

    aux = hash[hc];
    while (aux != NULL)
      {
        if (!strcmp(aux->nume, nume))
          break;
        aux = aux->urm;
      }

    if (aux == NULL)
      {
        aux = new NOD;

/*
        if (!aux)
          {
            printf("Not enough memory\n");
            exit(0);
          }
*/

        memcpy(aux->nume, nume, sizeof(nume));
        aux->num = ++nraces;
        aux->urm = hash[hc];
        hash[hc] = aux;
        race[i] = nraces;
      }
    else
      race[i] = aux->num;
  }

sort(1, n);

for (i = 1; i <= n; i++)
 inside[i] = 0;

dmaxmax = -1;
for (li = ls = 1; li <= n; li = ls+1)
  {
    for (j = li; j <= n; j++)
      if (race[o[j]] == race[o[li]])
        ls = j;
      else
        break;

    N = ls-li+1;

    if (N <= 100)
      {
        for (dmax = 0, i = li; i < ls; i++)
          for (j = i+1; j <= ls; j++)
            {
              d = dist2d(x[o[i]], y[o[i]], x[o[j]], y[o[j]]);

              if (d > dmax)
                dmax = d;
            }
      }
    else
      {
        /* Compute the convex hull */
        stack[1] = li; stack[2] = li+1; inside[li+1]=1; i = 2;

        /* Step 1 */
        for (p = li+2; p <= ls; p++)
          {
            if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
              continue;

            smn = -1;
            while (smn<0)
              {
                if (i == 1)
                  {
                    i++;
                    stack[i] = p;
                    inside[p] = 1;
                    smn = 0;
                  }
                else
                  {
                    a = y[o[stack[i-1]]]-y[o[stack[i]]];
                    b = x[o[stack[i]]]-x[o[stack[i-1]]];
                    c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

                    smn = semn(a,b,c,x[o[p]],y[o[p]]);

                    if (smn >= 0)
	                    {
	                      i++;
	                      stack[i] = p;
	                      inside[p] = 1;
	                    }
                    else
	                    {
	                      inside[stack[i]] = 0;
	                      i--;
	                    }
                  }
              }
          }

        /* Step 2 */
        for (p = ls; p >= li; p--)
          if (!inside[p])
            {
              if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
                continue;

              smn = -1;
              while (smn < 0)
                {
                  if (i==1)
	                  {
	                    i++;
	                    stack[i] = p;
	                    inside[p] = 1;
	                    smn = 0;
	                  }
                  else
	                  {
	                    a = y[o[stack[i-1]]]-y[o[stack[i]]];
	                    b = x[o[stack[i]]]-x[o[stack[i-1]]];
	                    c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

	                    smn = semn(a,b,c,x[o[p]],y[o[p]]);
	                    if (smn >= 0)
	                      {
	                        i++;
	                        stack[i] = p;
	                        inside[p] = 1;
	                      }
	                    else
	                      {
	                        inside[stack[i]] = 0;
	                        i--;
	                      }
	                  }
                }
            }

        N = i-1;
        i = j = 1;
        dmax = 0;

        while (i <= N)
          {
            dnew = d = dist2d(x[o[stack[i]]], y[o[stack[i]]], x[o[stack[j]]], y[o[stack[j]]]);
            if (d > dmax)
              dmax = d;

            do
              {
                j++;
                if (j > N)
                  j = 1;

                d = dnew;
                dnew = dist2d(x[o[stack[i]]], y[o[stack[i]]], x[o[stack[j]]], y[o[stack[j]]]);
                if (dnew > dmax)
                  dmax = dnew;
              }
            while (dnew > d);

            j--;
            if (j < 1)
              j = N;

            i++;
          }
      }

    if (dmax > dmaxmax)
      dmaxmax = dmax, worstrace = race[o[li]];
  }

/* output data */
freopen(fileout, "w", stdout);

for (i = 0; i < maxdim; i++)
  {
    aux = hash[i];
    while (aux != NULL)
      {
        if (aux->num == worstrace)
          {
            printf("%s", aux->nume);
            break;
          }

        aux = aux->urm;
      }
  }

return 0;
}