/* a GREEDY algorithm -> Time Complexity : O(N^3 * logN) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define filein "MERLIN.IN"
#define fileout "MERLIN.OUT"
#define maxn 100
#define minim(a,b) ((a) < (b) ? (a) : (b))
#define MIC 0

unsigned char nsq[maxn][maxn], whoi[maxn*maxn+1], whoj[maxn*maxn+1];
int pheap[maxn][maxn];
unsigned char board[maxn][maxn];
int i, j, p, q, N, M, n1, dimheap;

void up(int poz)
{
int ipoz, jpoz, itata, jtata, tata;

ipoz = whoi[poz];
jpoz = whoj[poz];

tata = poz >> 1;
itata = whoi[tata];
jtata = whoj[tata];

while (tata && nsq[itata][jtata] < nsq[ipoz][jpoz])
  {
    whoi[poz] = itata;
    whoj[poz] = jtata;
    whoi[tata] = ipoz;
    whoj[tata] = jpoz;
    pheap[whoi[poz]][whoj[poz]] = poz;
    pheap[whoi[tata]][whoj[tata]] = tata;

    poz = tata;
    tata = poz >> 1;
    itata = whoi[tata];
    jtata = whoj[tata];
  }
}

void down(int poz)
{
int ipoz, jpoz, p1, p2, v, vp1, vp2, ok;

ipoz = whoi[poz];
jpoz = whoj[poz];
v = nsq[whoi[poz]][whoj[poz]];

ok = 1;
while (ok)
  {
    ok = 0;

    p1 = poz << 1;
    if (p1 <= dimheap)
      vp1 = nsq[whoi[p1]][whoj[p1]];
    else
      vp1 = MIC;

    p2 = p1 + 1;
    if (p2 <= dimheap)
      vp2 = nsq[whoi[p2]][whoj[p2]];
    else
      vp2 = MIC;

    if (vp1 >= vp2 && vp1 > v)
      {
        ipoz = whoi[poz];
        jpoz = whoj[poz];
        whoi[poz] = whoi[p1];
        whoj[poz] = whoj[p1];
        whoi[p1] = ipoz;
        whoj[p1] = jpoz;

        pheap[whoi[poz]][whoj[poz]] = poz;
        pheap[whoi[p1]][whoj[p1]] = p1;

        poz = p1;
        ok = 1;
      }
    else
    if (vp2 >= vp1 && vp2 > v)
      {
        ipoz = whoi[poz];
        jpoz = whoj[poz];
        whoi[poz] = whoi[p2];
        whoj[poz] = whoj[p2];
        whoi[p2] = ipoz;
        whoj[p2] = jpoz;

        pheap[whoi[poz]][whoj[poz]] = poz;
        pheap[whoi[p2]][whoj[p2]] = p2;

        poz = p2;
        ok = 1;
      }
  }
}

void insheap(int i, int j)
{
dimheap++;
whoi[dimheap] = i;
whoj[dimheap] = j;
pheap[i][j] = dimheap;

up(dimheap);
}

void delmin(void)
{
whoi[1] = whoi[dimheap];
whoj[1] = whoj[dimheap];
dimheap--;

if (dimheap)
  down(1);
}

int main()
{
/* input data */
freopen(filein, "r", stdin);
scanf("%d %d", &N, &M);

memset(board, 0, sizeof(board));

n1 = N*N;

/* processsing */
memset(nsq, 0, sizeof(nsq));

dimheap = 0;

/*
randomize();
for (p = 0, q = N*N; p < q; p++)
  {
    do
      {
        i = rand()%N;
        j = rand()%N;
      }
    while (board[i][j]);

    board[i][j] = 1;
    nsq[i][j] = minim(N-i-1, N-j-1) +
                minim(N-i-1, j) +
                minim(i, N-j-1) +
                minim(i, j);

    insheap(i, j);
  }
*/

for (i = N-1; i >= 0; i--)
  for (j = 0; j < N; j++)
    {
      board[i][j] = 1;
      nsq[i][j] = minim(N-i-1, N-j-1) +
                  minim(N-i-1, j) +
                  minim(i, N-j-1) +
                  minim(i, j);

      insheap(i, j);
    }

while (dimheap && nsq[whoi[1]][whoj[1]])
  {
    p = whoi[1];
    q = whoj[1];

    /* dreapta - jos */
    for (i = p+1, j = q+1; i < N && j < N; i++, j++)
      if (board[p][q] && board[i][j] && board[p][j] && board[i][q])
        {
          nsq[p][q]--;

          nsq[i][j]--;
          down(pheap[i][j]);

          nsq[i][q]--;
          down(pheap[i][q]);

          nsq[p][j]--;
          down(pheap[p][j]);
        }

    /* stanga - sus */
    for (i = p-1, j = q-1; i >= 0 && j >= 0; i--, j--)
      if (board[p][q] && board[i][j] && board[p][j] && board[i][q])
        {
          nsq[i][j]--;
          down(pheap[i][j]);

          nsq[p][q]--;

          nsq[i][q]--;
          down(pheap[i][q]);

          nsq[p][j]--;
          down(pheap[p][j]);
        }

    /* dreapta - sus */
    for (i = p-1, j = q+1; i >= 0 && j < N; i--, j++)
      if (board[p][q] && board[i][j] && board[p][j] && board[i][q])
        {
          nsq[p][q]--;

          nsq[p][j]--;
          down(pheap[p][j]);

          nsq[i][q]--;
          down(pheap[i][q]);

          nsq[i][j]--;
          down(pheap[i][j]);
        }

    /* stanga - jos */
    for (i = p+1, j = q-1; i < N && j >= 0; i++, j--)
      if (board[p][q] && board[i][j] && board[p][j] && board[i][q])
        {
          nsq[p][q]--;

          nsq[p][j]--;
          down(pheap[p][j]);

          nsq[i][q]--;
          down(pheap[i][q]);

          nsq[i][j]--;
          down(pheap[i][j]);
        }

    board[p][q] = 0;
    n1--;

    if (nsq[p][q] != 0)
      printf("EROARE\n");

    delmin();
  }

/* output data */
freopen(fileout, "w", stdout);

n1 -= M;

for (i = 0; i < N; i++)
  for (j = 0; j < N; j++)
    if (n1 > 0 && (board[i][j] & 1))
      board[i][j] = 0, n1--;

for (i = 0; i < N; i++)
  {
    for (j = 0; j < N; j++)
      printf("%d", board[i][j]);
    printf("\n");
  }

return 0;
}