{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _GINFO_;

const MAXN = 1111;
      filein = 'GINFO.IN';
      fileout = 'GINFO.OUT';
      infinit = 1000000000;

type longv = array[1..MAXN] of longint;
     intv = array[1..MAXN] of integer;

     plist = ^list;
     list = record
              nod : integer;
              cost : longint;
              urm : plist;
            end;

     pqueue = ^queue;
     queue = record
               nod : integer;
               urm : pqueue;
             end;

var di : array[1..2] of longv;
    heap, pheap, tata, tip : intv;
    edge : array[1..MAXN] of plist;
    sel : array[1..MAXN] of boolean;
    flux : array[1..MAXN, 1..2] of byte;
    flux_, cap_ : array[1..2] of integer;
    d : array[1..MAXN] of longint;
    k, n, dimheap : integer;

procedure readinput;
var i, j, k, m : integer;
    aux : plist;
    c : longint;
begin
assign(input, filein);
reset(input);
read(n, m);

for i := 1 to n do
  edge[i] := nil;

for k := 1 to m do
  begin
    read(i, j, c);

    new(aux);
    aux^.nod := j;
    aux^.cost := c;
    aux^.urm := edge[i];
    edge[i] := aux;

    new(aux);
    aux^.nod := i;
    aux^.cost := c;
    aux^.urm := edge[j];
    edge[j] := aux;
  end;

close(input);
end;

procedure up(poz : integer);
var tata, aux : integer;
begin
tata := poz shr 1;

while (tata > 0) and (di[k][heap[tata]] > di[k][heap[poz]]) do
  begin
    aux := heap[tata];
    heap[tata] := heap[poz];
    heap[poz] := aux;
    pheap[heap[tata]] := tata;
    pheap[heap[poz]] := poz;

    poz := tata;
    tata := poz shr 1;
  end;
end;

procedure down(poz : integer);
var v, v1, v2 : longint;
    p1, p2, aux : integer;
    ok : boolean;
begin
v := di[k][heap[poz]];
ok := true;

while (ok) do
  begin
    ok := false;

    p1 := poz shl 1;
    if (p1 <= dimheap) then
      v1 := di[k][heap[p1]]
    else
      v1 := infinit;

    p2 := p1+1;
    if (p2 <= dimheap) then
      v2 := di[k][heap[p2]]
    else
      v2 := infinit;

    if (v1 <= v2) and (v1 < v) then
      begin
        aux := heap[poz];
        heap[poz] := heap[p1];
        heap[p1] := aux;
        pheap[heap[poz]] := poz;
        pheap[heap[p1]] := p1;

        poz := p1;
        ok := true;
      end
    else
    if (v2 <= v1) and (v2 < v) then
      begin
        aux := heap[poz];
        heap[poz] := heap[p2];
        heap[p2] := aux;
        pheap[heap[poz]] := poz;
        pheap[heap[p2]] := p2;

        poz := p2;
        ok := true;
      end;
  end;
end;

procedure insheap(nod : integer);
begin
inc(dimheap);
heap[dimheap] := nod;
sel[nod] := true;
pheap[nod] := dimheap;
up(dimheap);
end;

procedure delmin;
begin
heap[1] := heap[dimheap];
pheap[heap[1]] := 1;
dec(dimheap);

if (dimheap >= 1) then
  down(1);
end;

procedure dijkstra_cu_heap(s : integer);
var i, j : integer;
    c : longint;
    aux : plist;
begin
for i := 1 to n do
  di[s][i] := infinit;

fillchar(sel, sizeof(sel), false);

dimheap := 0;
di[s][s] := 0;
insheap(s);

while (dimheap >= 1) do
  begin
    i := heap[1];

    aux := edge[i];
    while (aux <> nil) do
      begin
        j := aux^.nod;
        c := aux^.cost;

        if (di[s][i] + c < di[s][j]) then
          begin
            di[s][j] := di[s][i] + c;

            if (not sel[j]) then
              insheap(j)
            else
              up(pheap[j]);
          end;

        aux := aux^.urm;
      end;

    delmin;
  end;
end;

procedure min_cost_max_flow;
var i, j, k, last : longint;
    cst, cfin, aux : pqueue;
begin
fillchar(flux, sizeof(flux), 0);
fillchar(flux_, sizeof(flux_), 0);
cap_[1] := n shr 1;
cap_[2] := cap_[1];
last := n+3;

for k := 1 to n do
  begin
    fillchar(d, sizeof(d), 63);
    fillchar(sel, sizeof(sel), false);
    fillchar(tata, sizeof(tata), 0);
    fillchar(tip, sizeof(tip), 0);

    d[k] := 0;
    new(cst);
    cst^.nod := k;
    cst^.urm := nil;
    cfin := cst;
    sel[k] := true;

    { Bellman - Kalaba }
    while (cst <> nil) do
      begin
        i := cst^.nod;

        if (i <= n) then
          begin
            for j := 1 to 2 do
              if (flux[i][j] = 0) and (d[i] + di[j][i] < d[n+j]) then
                begin
                  d[n+j] := d[i] + di[j][i];
                  tata[n+j] := i;
                  tip[n+j] := 1;

                  if (not sel[n+j]) then
                    begin
                      sel[n+j] := true;

                      new(aux);
                      aux^.nod := n+j;
                      aux^.urm := nil;
                      cfin^.urm := aux;
                      cfin := aux;
                    end;
                end
          end
        else
          begin
            for j := 1 to k-1 do
              if (flux[j][i-n] = 1) and (d[i] - di[i-n][j] < d[j]) then
                begin
                  d[j] := d[i] - di[i-n][j];
                  tata[j] := i;
                  tip[j] := 2;

                  if (not sel[j]) then
                    begin
                      sel[j] := true;

                      new(aux);
                      aux^.nod := j;
                      aux^.urm := nil;
                      cfin^.urm := aux;
                      cfin := aux;
                    end;
                end;

            if (flux_[i-n] < cap_[i-n]) and (d[last] > d[i]) then
              begin
                d[last] := d[i];
                tata[last] := i;
                tip[last] := 1;
              end;
          end;

        sel[i] := false;
        aux := cst^.urm;
        dispose(cst);
        cst := aux;
      end;

    { update the flow }
    inc(flux_[tata[last]-n]);

    i := tata[last];
    while (i <> k) do
      begin
        if (tip[i] = 1) then
          inc(flux[tata[i]][i-n])
        else
          dec(flux[i][tata[i]-n]);

        i := tata[i];
      end;
  end;
end;

procedure writeoutput;
var first : boolean;
    i, j : integer;
begin
assign(output, fileout);
rewrite(output);

for j := 1 to 2 do
  begin
    first := true;
    for i := 1 to n do
      if (flux[i][j] = 1) then
        begin
          if (not first) then
            write(' ');
          write(i);
          first := false;
        end;

    writeln;
  end;

close(output);
end;

begin
readinput;

for k := 1 to 2 do
  dijkstra_cu_heap(k);

min_cost_max_flow;
writeoutput;
end.