{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _OCR_;

const filein = 'OCR.IN';
      fileout = 'OCR.OUT';
      MAXM = 16;
      MAXN = 111;
      infinit = 1000000000;

type flowmatrix = array[0..2*MAXN+1, 0..2*MAXN+1] of byte;
     pfm = ^flowmatrix;

     pqueue = ^queue;
     queue = record
               nod : integer;
               urm : pqueue;
             end;

var a, b : array[1..MAXM, 1..MAXM] of byte;
    d : array[0..2*MAXN+1] of longint;
    tata, tip : array[0..2*MAXN+1] of integer;
    inq : array[0..2*MAXN+1] of boolean;
    cap, flux, cost : pfm;
    i, j, k, l, m, n, p, q, cc, n1a, n1a_, n1b, last, fmax: integer;
    ch, currch, bestch : char;
    bestcost, currcost : longint;
    cst, cfin, aux : pqueue;

procedure mincostmaxflow(cmin, cmax : byte);
begin
for i := 1 to n1a do
  cap^[0,i] := cmax;

while (true) do
  begin
    for i := 1 to last do
      begin
        d[i] := infinit;
        inq[i] := false;
        tata[i] := 0;
        tip[i] := 0;
      end;

    inq[0] := true;
    d[0] := 0;

    new(cst);
    cst^.nod := 0;
    cst^.urm := nil;
    cfin := cst;

    { Bellman-Kalaba }
    while (cst<>nil) do
      begin
        i := cst^.nod;

        if (i = 0) then
          begin
            for j := 1 to n1a do
              if (flux^[0,j] < cap^[0,j]) and (d[j] > d[0]) then
                begin
                  d[j] := d[0];
                  tata[j] := 0;
                  tip[j] := 1;

                  if (not inq[j]) then
                    begin
                      inq[j] := true;
                      new(aux);
                      aux^.nod := j;
                      aux^.urm := nil;
                      cfin^.urm := aux;
                      cfin := aux;
                    end;
                end;
          end
        else
        if (i <= n1a) then
          begin
            for j := n1a+1 to n1a+n1b do
              if (flux^[i,j] < cap^[i,j]) and (d[i]+cost^[i,j] < d[j]) then
                begin
                  d[j] := d[i] + cost^[i,j];
                  tata[j] := i;
                  tip[j] := 1;

                  if (not inq[j]) then
                    begin
                      inq[j] := true;
                      new(aux);
                      aux^.nod := j;
                      aux^.urm := nil;
                      cfin^.urm := aux;
                      cfin := aux;
                    end;
                end;
          end
        else
        if (i <= n1a+n1b) then
          begin
            if (flux^[i,last] < cap^[i,last]) and (d[i] < d[last]) then
              begin
                d[last] := d[i];
                tata[last] := i;
                tip[last] := 1;
              end;

            for j := 1 to n1a do
              if (flux^[j,i] > 0) and (d[i]-cost^[j,i] < d[j]) then
                begin
                  d[j] := d[i]-cost^[j,i];
                  tata[j] := i;
                  tip[j] := 2;

                  if (not inq[j]) then
                    begin
                      inq[j] := true;
                      new(aux);
                      aux^.nod := j;
                      aux^.urm := nil;
                      cfin^.urm := aux;
                      cfin := aux;
                    end;
                end;
          end;

        inq[i] := false;
        aux := cst^.urm;
        dispose(cst);
        cst := aux;
      end;

    if (d[last] = infinit) then
      break;

    inc(fmax);
    currcost := currcost + d[last];

    i := last;
    while (i > 0) do
      begin
        if (tip[i] = 1) then
          flux^[tata[i],i] := flux^[tata[i],i] + 1
        else
          flux^[i,tata[i]] := flux^[i,tata[i]] - 1;

        i := tata[i];
      end;
  end;
end;

begin
assign(input, filein);
reset(input);

{ read the matrix a }

n1a := 0;
for i := 1 to MAXM do
  for j := 1 to MAXM do
    begin
      repeat
        read(ch);
      until (ch = '0') or (ch = '1');

      a[i,j] := ord(ch)-48;
      n1a := n1a+a[i,j];
    end;

bestcost := infinit;

new(cap);
new(flux);
new(cost);

readln(n);
for cc := 1 to n do
  begin
    readln(currch);

    { read the matrix b }
    n1b := 0;
    for i := 1 to MAXM do
      for j := 1 to MAXM do
        begin
          repeat
            read(ch);
          until (ch = '0') or (ch = '1');

          b[i,j] := ord(ch)-48;
          n1b := n1b+b[i,j];
        end;
    readln;

    { build the graph }
    fillchar(cap^, sizeof(cap^), 0);
    fillchar(flux^, sizeof(flux^), 0);
    fillchar(cost^, sizeof(cost^), 0);
    last := n1a + n1b + 1;

    n1a_ := n1a;

    if (n1a < n1b) then
      begin
        p := 0;
        for i := 1 to MAXM do
          for j := 1 to MAXM do
            if (a[i,j] = 1) then
              begin
                inc(p);

                q := 0;
                for k := 1 to MAXM do
                  for l := 1 to MAXM do
                    if (b[k,l] = 1) then
                      begin
                        inc(q);

                        cost^[p,n1a+q] := abs(i-k) + abs(j-l);
                        cap^[p,n1a+q] := 1;
                        cap^[n1a+q,last] := 1;
                      end;
              end;
      end
    else
      begin
        p := 0;
        for i := 1 to MAXM do
          for j := 1 to MAXM do
            if (a[i,j] = 1) then
              begin
                inc(p);

                q := 0;
                for k := 1 to MAXM do
                  for l := 1 to MAXM do
                    if (b[k,l] = 1) then
                      begin
                        inc(q);

                        cost^[q,n1b+p] := abs(i-k) + abs(j-l);
                        cap^[q,n1b+p] := 1;
                        cap^[n1b+p,last] := 1;
                      end;
              end;

        p := n1a;
        n1a := n1b;
        n1b := p;
      end;

    m := n1b div n1a;
    currcost := 0;

    fmax := 0;
    mincostmaxflow(0, m);
    mincostmaxflow(m, m+1);
    {
    writeln(currch, ' : ', currcost);
    }
    if (currcost < bestcost) then
      begin
        bestcost := currcost;
        bestch := currch;
      end;

    n1a := n1a_;
  end;

assign(output, fileout);
rewrite(output);
writeln(bestch);
close(output);
end.