{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 5000,0,655360}

Program _DANEEL_;

const filein = 'DANEEL.IN';
      fileout = 'DANEEL.OUT';
      MAXN = 100;
      MAXM = 128;
      MAXT = 9911;
      infinit = 15000;

type plist = ^list;
     list = record
              nod, t, c : byte;
              urm : plist;
            end;

var cmin : array [1..MAXN, 0..MAXM-1] of longint;
    edge : array [1..MAXN] of plist;
    i, j, k, m, n, sum, t, c, tnext, cnext, tbest, tmodMAXM : longint;
    aux : plist;

begin
{ read data }
assign(input, filein);
reset(input);
read(n, m, sum);

for i := 1 to n do
  edge[i] := nil;

for k := 1 to m do
  begin
    read(i, j, t, c);

    new(aux);
    aux^.nod := i;
    aux^.t := t;
    aux^.c := c;
    aux^.urm := edge[j];
    edge[j] := aux;

    new(aux);
    aux^.nod := j;
    aux^.t := t;
    aux^.c := c;
    aux^.urm := edge[i];
    edge[i] := aux;
  end;

close(input);

{ compute }

tbest := infinit;
for i := 1 to n do
  cmin[i,0] := infinit;
cmin[1,0] := 0;

for t := 1 to MAXT do
  begin
    tmodMAXM := t and 127;

    for i := 1 to n do
      begin
        cmin[i, tmodMAXM] := infinit;

        aux := edge[i];
        while (aux <> nil) do
          begin
            j := aux^.nod;
            tnext := aux^.t;
            cnext := aux^.c;

            if (t >= tnext) and (cmin[j, (t-tnext) and 127] + cnext <
                                 cmin[i, tmodMAXM]) then
              cmin[i, tmodMAXM] := cmin[j, (t-tnext) and 127] + cnext;

            aux := aux^.urm;
          end;
      end;

    if (cmin[n, tmodMAXM] <= sum) and (cmin[n, tmodMAXM] < infinit) then
      begin
        tbest := t;
        break;
      end;
  end;

{ write data }
assign(output, fileout);
rewrite(output);
if (tbest = infinit) then
  writeln(-1)
else
  writeln(tbest);
close(output);
end.