#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#define filein "AOE.IN"
#define fileout "AOE.OUT"
#define maxn 101
#define eps 1e-10
#define maxstages 3

long int L[maxn], i, j, k, N, stage;
long double Ri, Rs, Rmid, angle, anglemax, area, pi;
long double epsok[maxstages] = {1e-9, 1e-10, 1e-11};

long double ANGLE(long double d, long double R)
{
long double alfa;

alfa = acosl(d/(2.0*R));
return pi - 2.0*alfa;
}

long double AREA(long double d, long double R)
{
long double cosalfa, sinalfa, p;

cosalfa = d/(2.0*R);
sinalfa = sqrtl(1.0-cosalfa*cosalfa);
return R*sinalfa*d/2.0;

/*
p = (2.0*R + d) / 2.0;
return sqrtl(p*(p-R)*(p-R)*(p-d));
*/
}

void print(long double area)
{
if (area < 0.0)
  area = 0.0;

printf("%.2Lf\n", area);
}

int main()
{
/* read input data */
freopen(filein, "r", stdin);

scanf("%ld", &N);
for (i = 1; i <= N; i++)
  scanf("%ld", &L[i]);

for (i = 1; i < N; i++)
  for (j = i+1; j <= N; j++)
    if (L[i] > L[j])
      {
        k = L[i]; L[i] = L[j]; L[j] = k;
      }

freopen(fileout, "w", stdout);

/* Step #1 */
pi = 2.0 * acosl(0);
Ri = L[N] / 2.0;
Rs = 1e6;

area = -1;
stage = 0;
while (fabsl(Rs-Ri) > eps)
  {
    Rmid = (Ri + Rs) / 2.0;

    angle = 0;
    for (i = 1; i <= N; i++)
      angle += ANGLE(L[i], Rmid);

    if (fabsl(angle - 2.0*pi) < epsok[stage])
      {
        area = 0;
        for (i = 1; i <= N; i++)
          area += AREA(L[i], Rmid);
        Ri = Rmid;

        if (stage < maxstages-1)
          stage++;
      }
    else
    if (angle < 2*pi)
      Rs = Rmid;
    else
      Ri = Rmid;
  }

if (area > -1.0)
  {
    print(area);
    return 0;
  }

/* Step #2 */

Ri = L[N] / 2.0;
Rs = 1e5;

while (fabsl(Rs-Ri) > eps)
  {
    Rmid = (Rs + Ri) / 2.0;

    angle = 0;
    for (i = 1; i < N; i++)
      angle += ANGLE(L[i], Rmid);

    anglemax = ANGLE(L[N], Rmid);

    if (angle > anglemax /*|| fabsl(angle-anglemax) < epsok */)
      Rs = Rmid;
    else
      Ri = Rmid;
  }

area = 0;
for (i = 1; i < N; i++)
  area += AREA(L[i], Rmid);
area -= AREA(L[i], Rmid);

if (fabsl(Rmid - 1e5) < 1e-4)
  area = 0;

print(area);

return 0;
}