/* Time Complexity: O(N*N*logN) */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define filein "SENTINEL.IN"
#define fileout "SENTINEL.OUT"
#define maxn 1010
#define eps 1e-6
#define ungeps 1e-9

int i, j, k, m, n, curr, best, nint, max = 0;
int x[maxn], y[maxn], tip[4*maxn], o[4*maxn], oaux[4*maxn];
double R, PI, PIp2;
double angle[4*maxn];

void readdata(void);
void compute(void);
void writedata(void);

int main()
{
readdata();
compute();
writedata();

return 0;
}

void readdata(void)
{
int i, r;

freopen(filein, "r", stdin);

scanf("%d %d", &n, &r);
R = r;

for (i = 1; i <= n; i++)
  scanf("%d %d", &x[i], &y[i]);
}

double dist2d(double xa, double ya, double xb, double yb)
{
double dx = xa - xb, dy = ya - yb;
return sqrt(dx*dx + dy*dy);
}

void sort(int li, int ls)
{
if (li < ls)
  {
    sort(li, (li+ls) >> 1);
    sort(((li+ls) >> 1) + 1, ls);

    k = li - 1;
    m = (li+ls) >> 1;
    i = li;
    j = m + 1;

    while (i <= m && j <= ls)
      {
        k++;

        if ((angle[o[i]] < angle[o[j]] && fabs(angle[o[i]] - angle[o[j]]) >= ungeps) ||
           (fabs(angle[o[i]] - angle[o[j]]) < ungeps && tip[o[i]] > 0))
          {
            oaux[k] = o[i];
            i++;
          }
        else
          {
            oaux[k] = o[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            oaux[k] = o[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            oaux[k] = o[i];
          }
      }

    for (k = li; k <= ls; k++)
      o[k] = oaux[k];
  }
}

void compute(void)
{
int i, j, k;
double d, u, alfa;

PIp2 = acos(0);
PI = 2.0 * PIp2;

for (i = 1; i <= n; i++)
  {
    nint = 0;

    for (j = 1; j <= n; j++)
      if (j != i)
        {
          d = dist2d((double)(x[i]), (double)(y[i]), (double)(x[j]), (double)(y[j]));

          if (d < 2.0*R || fabs(d - 2.0*R) < eps)
            {
              u = atan2(y[j] - y[i], x[j] - x[i]);
              if (u < 0.0)
                u += 2*PI;

              alfa = acos(d/(2*R));

              nint++;
              angle[nint] = u - alfa;
              tip[nint] = j;
              nint++;
              angle[nint] = u + alfa;
              tip[nint] = -j;

              if (u < PI)
                {
                  u += 2*PI;

                  nint++;
                  angle[nint] = u - alfa;
                  tip[nint] = j;
                  nint++;
                  angle[nint] = u + alfa;
                  tip[nint] = -j;
                }
            }
        }

    for (j = 1; j <= nint; j++)
      o[j] = j;

    sort(1, nint);

    best = curr = 0;

    for (j = 1; j <= nint; j++)
      {
        if (tip[o[j]] > 0)
          curr++;
        else
          curr--;

        if (curr > best)
          best = curr;
      }

    if (best > max)
      max = best;
  }
}

void writedata(void)
{
FILE *fout = fopen(fileout, "w");
fprintf(fout, "%d\n", max + 1);
fclose(fout);
}