{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _KEOPS_;

const filein = 'KEOPS.IN';
      fileout = 'KEOPS.OUT';
      MAXN = 250;
      infinit = 64000;
      dl : array [1..4] of integer = (-1, 0, +1, 0);
      dc : array [1..4] of integer = (0, +1, 0, -1);

type bytelinie = array [1..MAXN] of byte;
     pbytelinie = ^bytelinie;
     wordlinie = array [1..MAXN] of word;
     pwordlinie = ^wordlinie;
     pq = ^q;
     q = record
           l, c : integer;
           urm : pq;
         end;

var a : array [1..MAXN] of pbytelinie;
    d : array [1..2, 1..MAXN] of pwordlinie;
    i, j, k, m, n, l1, c1, l2, c2 : integer;
    min : word;
    ch : char;

procedure computedist(ls, cs, t : integer);
var l, c, i, j, k, lnext, cnext : integer;
    cst, cfin, aux : pq;
begin
for i := 1 to m do
  for j := 1 to n do
    d[t,i]^[j] := infinit;

d[t,ls]^[cs] := 0;

new(cst);
cst^.l := ls;
cst^.c := cs;
cst^.urm := nil;
cfin := cst;


while (cst <> nil) do
  begin
    l := cst^.l;
    c := cst^.c;

    for k := 1 to 4 do
      begin
        lnext := l + dl[k];
        cnext := c + dc[k];

        if (lnext >=1 ) and (lnext <= m) and (cnext >= 1) and (cnext <= n) and
          (d[t,lnext]^[cnext] = infinit) and (a[lnext]^[cnext] = 0) then
          begin
            d[t,lnext]^[cnext] := d[t,l]^[c] + 1;

            new(aux);
            aux^.l := lnext;
            aux^.c := cnext;
            aux^.urm := nil;

            cfin^.urm := aux;
            cfin := aux;
          end;
      end;

    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;
end;

function minim(a, b : word) : word;
begin
if (a < b) then
  minim := a
else
  minim := b;
end;

function maxim(a, b : word) : word;
begin
if (a > b) then
  maxim := a
else
  maxim := b;
end;

begin
assign(input, filein);
reset(input);
read(m, n);
read(l1, c1);
read(l2, c2);

for i := 1 to m do
  begin
    new(a[i]);
    new(d[1,i]);
    new(d[2,i]);
  end;

for i := 1 to m do
  for j := 1 to n do
    begin
      repeat
        read(ch);
      until (ch = '0') or (ch = '1');

      a[i]^[j] := ord(ch) - ord('0');
    end;

close(input);

computedist(l1, c1, 1);
computedist(l2, c2, 2);

min := infinit;
for i := 1 to m do
  for j := 1 to n do
    min := minim(min, maxim(d[1,i]^[j], d[2,i]^[j]));

assign(output, fileout);
rewrite(output);

if (min = infinit) then
  writeln(-1)
else
  writeln(min);

close(output);
end.