/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <string.h>
#include <math.h>
#define filein "TOWERS.IN"
#define fileout "TOWERS.OUT"
#define maxn 1100
#define maxim(a,b) (a > b ? (a) : (b))

long int xM[maxn], yM[maxn], xN[maxn], yN[maxn], x[maxn], y[maxn];
long int o[maxn], oaux[maxn], inside[maxn], stack[maxn];
long int  xpM[maxn], ypM[maxn], xpN[maxn], ypN[maxn];
long int i, j, k, m, p, smn, M, N, nM, nN, ninM, ninN;
long int a, b, c;

long int semn(long int a, long int b, long int c, long int x, long int y)
{
long int r = a*x + b*y + c;

if (r == 0) return 0;
else
  if (r > 0) return 1;
else
  return -1;
}

void sort(long int li, long int ls)
{
if (ls > li)
  {
    sort(li, (li+ls)>>1);
    sort(((li+ls)>>1)+1, ls);

    k = li-1;
    i = li;
    m = (li+ls)>>1;
    j = m+1;

    while (i <= m && j <= ls)
      {
        k++;

        if (x[o[i]] < x[o[j]] ||
           (x[o[i]] == x[o[j]] && y[o[i]] < y[o[j]]))
          {
            oaux[k]=o[i];
            i++;
          }
        else
          {
            oaux[k]=o[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            oaux[k] = o[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            oaux[k] = o[i];
          }
      }

    for (k = li; k <= ls; k++)
      o[k] = oaux[k];
  }
}

void convexhull(long int N, long int xp[], long int yp[], long int *np)
{
for (i = 1; i <= N; i++)
  o[i] = i;

sort(1, N);

memset(inside, 0, sizeof(inside));
stack[1] = 1; stack[2] = 2; inside[2]=1; i = 2;

/* Step 1 */
for (p = 3; p <= N; p++)
  {
    if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
      continue;

    smn = -1;
    while (smn<0)
      {
        if (i == 1)
          {
            i++;
            stack[i] = p;
            inside[p] = 1;
            smn = 0;
          }
        else
          {
            a = y[o[stack[i-1]]]-y[o[stack[i]]];
            b = x[o[stack[i]]]-x[o[stack[i-1]]];
            c = x[o[stack[i-1]]] * y[o[stack[i]]] -
                x[o[stack[i]]] * y[o[stack[i-1]]];

            smn = semn(a,b,c,x[o[p]],y[o[p]]);

            if (smn >= 0)
	            {
	              i++;
	              stack[i] = p;
	              inside[p] = 1;
	            }
            else
	            {
	              inside[stack[i]] = 0;
	              i--;
	            }
          }
      }
  }

/* Step 2 */
for (p = N; p >= 1; p--)
  if (!inside[p])
    {
      if (x[o[p]] == x[o[stack[i]]] && y[o[p]] == y[o[stack[i]]])
        continue;

      smn = -1;
      while (smn < 0)
        {
          if (i==1)
	          {
	            i++;
	            stack[i] = p;
	            inside[p] = 1;
	            smn = 0;
	          }
          else
	          {
	            a = y[o[stack[i-1]]]-y[o[stack[i]]];
	            b = x[o[stack[i]]]-x[o[stack[i-1]]];
	            c = x[o[stack[i-1]]] * y[o[stack[i]]] -
                  x[o[stack[i]]] * y[o[stack[i-1]]];

	            smn = semn(a,b,c,x[o[p]],y[o[p]]);
	            if (smn >= 0)
	              {
	                i++;
	                stack[i] = p;
	                inside[p] = 1;
	              }
	            else
	              {
	                inside[stack[i]] = 0;
	                i--;
	              }
	          }
        }
    }

for (j = 1; j <= i; j++)
  xp[j] = x[o[stack[j]]], yp[j] = y[o[stack[j]]];

*np = i;
}

long int inbetween(long int a, long int b, long int c)
{
if ((a <= c && c <= b) || (b <= c && c <= a))
  return 1;
else
  return 0;
}

void computein(long int xn[], long int yn[], long int n, long int xp[], long int yp[], long int np, long int *nin)
{
long int ok, un1;

*nin = 0;

for (i = 1; i <= n; i++)
  {
    ok = 1;
    un1 = 0;

    for (j = 1; j < np; j++)
      {
        a = yp[j] - yp[j+1];
        b = xp[j+1] - xp[j];
        c = xp[j] * yp[j+1] -
            xp[j+1] * yp[j];

        smn = semn(a, b, c, xn[i], yn[i]);

        if (smn < 0)
          {
            ok = 0;
            break;
          }
        else
        if (smn == 0)
          {
            if (inbetween(xp[j], xp[j+1], xn[i]) &&
                inbetween(yp[j], yp[j+1], yn[i]))
              {
                un1 = 1;
                break;
              }
          }
        else
          un1 = 1;
      }

    if (ok && un1)
      (*nin)++;
  }
}

int main()
{
/* citeste datele de intrare */

freopen(filein, "r", stdin);

scanf("%ld %ld", &M, &N);

for (i = 1; i <= M; i++)
  scanf("%ld %ld", &xM[i], &yM[i]);

for (i = 1; i <= N; i++)
  scanf("%ld %ld", &xN[i], &yN[i]);

/* Convex Hull pt. Elfii Padurii */
for (i = 1; i <= M; i++)
  x[i] = xM[i], y[i] = yM[i];

if (M < 3)
  {
    for (i = 1; i <= M; i++)
      xpM[i] = x[i], ypM[i] = y[i];

    xpM[M+1] = x[1], ypM[M+1] = y[1];

    nM = M+1;
  }
else
  convexhull(M, xpM, ypM, &nM);

/* Convex Hull pt. Elfii Noptii */
for (i = 1; i <= N; i++)
  x[i] = xN[i], y[i] = yN[i];

if (N < 3)
  {
    for (i = 1; i <= N; i++)
      xpN[i] = x[i], ypN[i] = y[i];

    xpN[N+1] = x[1], ypN[N+1] = y[1];

    nN = N+1;
  }
else
  convexhull(N, xpN, ypN, &nN);

/* calculeaza ninM */
if (nN >= 2)
  computein(xM, yM, M, xpN, ypN, nN, &ninM);
else
  ninM = 0;

/* calculeaza ninN */
if (nM >= 2)
  computein(xN, yN, N, xpM, ypM, nM, &ninN);
else
  ninN = 0;

/* afisaza rezultatele */

freopen(fileout, "w", stdout);

printf("%ld %ld\n", ninM, ninN);

return 0;
}