{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ just another max-flow problem... :( }

Program _MAGIC_;

const filein = 'MAGIC.IN';
      fileout = 'MAGIC.OUT';
      MAXN = 31;

var a, b : array [1..MAXN, 1..MAXN] of integer;
    cap, flux : array [0..2*MAXN+1, 0..2*MAXN+1] of byte;
    tata, tip : array [0..2*MAXN+1] of integer;
    sel : array [0..2*MAXN+1] of boolean;
    sl, sc : array [1..MAXN] of integer;
    q : array [1..2*MAXN+2] of integer;
    i, j, k, m, n, p, s, last : integer;

procedure nosol;
begin
assign(output, fileout);
rewrite(output);
writeln(-1);
close(output);
halt(0);
end;

procedure maxflow;
var i, j, k, p, po, nel : integer;
begin
for i := 0 to last do
  for j := 0 to last do
    flux[i, j] := 0;

repeat
  for i := 0 to last do
    begin
      sel[i] := false;
      tata[i] := 0;
      tip[i] := 0;
    end;

  po := 1;
  nel := 1;
  q[1] := 0;
  sel[0] := true;

  while (po <= nel) do
    begin
      i := q[po];

      for j := 1 to last do
        if (not sel[j]) then
          begin
            if (cap[i, j] > flux[i, j]) then
              begin
                tata[j] := i;
                tip[j] := 1;
                sel[j] := true;

                inc(nel);
                q[nel] := j;
              end;

            if (flux[j, i] > 0) then
              begin
                tata[j] := i;
                tip[j] := 2;
                sel[j] := true;

                inc(nel);
                q[nel] := j;
              end;
          end;

      inc(po);
    end;

  if (sel[last]) then
    begin
      p := last;
      while (p > 0) do
        begin
          if (tip[p] = 1) then
            inc(flux[tata[p], p])
          else
            dec(flux[p, tata[p]]);

          p := tata[p];
        end;
    end;

until (not sel[last]);
end;

begin
{ input data }
assign(input, filein);
reset(input);
read(m, n, p);

fillchar(sl, sizeof(sl), 0);
fillchar(sc, sizeof(sc), 0);

for i := 1 to m do
  for j := 1 to n do
    begin
     read(a[i, j]);

     sl[i] := sl[i] + a[i, j];
     sc[j] := sc[j] + a[i, j];

     b[i, j] := p * (a[i,j] div p);
    end;

close(input);

{ compute stuff }

fillchar(cap, sizeof(cap), 0);
last := m + n + 1;

for i := 1 to m do
  begin
    s := 0;
    for j := 1 to n do
      s := s + b[i, j];

    if (((sl[i] - s) mod p) > 0) then
      nosol;

    cap[0, i] := (sl[i] - s) div p;
  end;

for j := 1 to n do
  begin
    s := 0;
    for i := 1 to m do
      s := s + b[i, j];

    if (((sc[j] - s) mod p) > 0) then
      nosol;

    cap[m+j, last] := (sc[j] - s) div p;
  end;

for i := 1 to m do
  for j := 1 to n do
    if (b[i,j] < a[i,j]) then
      cap[i, m+j] := 1;

maxflow;

for i := 1 to m do
  if (flux[0, i] < cap[0, i]) then
    nosol;

for i := m + 1 to m + n do
  if (flux[i, last] < cap[i, last]) then
    nosol;

for i := 1 to m do
  for j := 1 to n do
    if (flux[i, m+j] = 1) then
      b[i, j] := b[i, j] + p;

{ output data }
assign(output, fileout);
rewrite(output);

for i := 1 to m do
  begin
    write(b[i, 1]);
    for j := 2 to n do
      write(' ', b[i, j]);
    writeln;
  end;

close(output);
end.