/*
  Time Complexity : O(K * K * logR)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <dos.h>
#define filein "HALLWAY.IN"
#define fileout "HALLWAY.OUT"
#define maxn 1010
#define eps 1e-9
#define timelimit 17

long int x[maxn], y[maxn], cc[maxn], i, j, m, n, K, ncc;
int touchup[maxn], touchdown[maxn], ok;
double li, ls, R, R2;

long int *t2, t1;

void printsol(void)
{
printf("%ld\n", *t2-t1);

freopen(fileout, "w", stdout);
printf("%.8lf\n", R);
exit(0);
}

void df(int nod)
{
int i;
double d;

if (*t2 - t1 >= timelimit)
  printsol();

cc[nod] = ncc;

if (y[nod] - 2*R < 0 || fabs(y[nod] - 2*R) < eps)
  touchdown[ncc] = 1;
if (y[nod] + 2*R > n || fabs(y[nod] - n + 2*R) < eps)
  touchup[ncc] = 1;

if (touchdown[ncc] && touchup[ncc])
  {
    ok = 0;
    return;
  }

for (i = 1; i <= K && ok; i++)
  if (i != nod && !cc[i])
    {
      d = (x[i]-x[nod])*(x[i]-x[nod]) +
          (y[i]-y[nod])*(y[i]-y[nod]);

      if (d < R2 || fabs(R2-d) < eps)
        df(i);
    }
}

int main()
{
t2 = MK_FP(0, 0x46c);
t1 = *t2;

freopen(filein, "r", stdin);
scanf("%ld %ld %ld", &m, &n, &K);

for (i = 1; i <= K; i++)
  scanf("%ld %ld", &x[i], &y[i]);

/* elimina obstacolele din afara cordidorului (daca exista) */
j = 0;
for (i = 1; i <= K; i++)
  if (x[i] >= 0 && x[i] <= m && y[i] >= 0 && y[i] <= n)
    {
      j++;
      x[j] = x[i];
      y[j] = y[i];
    }

K = j;

li = 0;
ls = 0.5 * n;

while (fabs(ls-li) > eps)
  {
    R = 0.5 * (li + ls);
    R2 = 4.0 * R * R;

    memset(cc, 0, sizeof(cc));
    memset(touchup, 0, sizeof(touchup));
    memset(touchdown, 0, sizeof(touchdown));

    ncc = 0; ok = 1;
    for (i = 1; i <= K && ok; i++)
      if (!cc[i])
        {
          ncc++;
          df(i);
        }

    if (ok)
      li = R;
    else
      ls = R;
  }

printsol();

return 0;
}