#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 210
#define INF 6666
#define QL 50000

int nv[NMAX];
unsigned char far *v[NMAX];
unsigned char far *c[NMAX];

int N, M;

int f[NMAX], d[NMAX];

unsigned char q[QL];
int viz[NMAX];
int t[NMAX];

int s, np;

int cycle(int start, int nod)
{

	while (start)
	{
		if (start == nod)
			return 1;
		
		start = t[start];
	}

	return 0;
}

int eflux()
{
	long int i, p1 = 0, p2 = 0, cost, cur, poz, min;

	memset(t, 0, sizeof(t));

	for (i = 1; i <= N; i++)
		if (!f[i])
		{
			d[i] = 0;
			q[p2++] = i;
			viz[i] = 1;
		}
		else
		{
			d[i] = INF;
			viz[i] = 0;
		}

	for (i=N+1; i <= 2*N; i++)
	{
		d[i] = INF;
		viz[i] = 0;
	}

	while (p1 < p2)
	{
		cur = q[p1];

		if (viz[t[cur]])
		{
			viz[cur] = 0;
			p1++;
			continue;
		}

		if (cur <= N)
			for (i = 0; i < nv[cur]; i++)
			{
				cost = d[cur] + c[cur][v[cur][i]];
				if ((cost < d[v[cur][i]]) && (v[cur][i] != f[cur]))
				{
					d[v[cur][i]] = cost;
					
					if (!viz[ v[cur][i] ])
					{
						viz[v[cur][i]] = 1;
						q[p2] = v[cur][i];
						p2++;
					}

					t[v[cur][i]] = cur;
				}
			}
		else
		{
			if (f[cur])
			{
				cost = d[cur] - c[f[cur]][cur];

				if (cost < 0)
				{
					//printf("%d => %d %d\n", cur, f[cur], t[cur]);
					//for (i = 1; i <= 2*N; i++)
					//	printf("%d : %d\n", i, d[i]);
					
					/*
					i = cur;
					while (i)
					{
						printf(" %d ", i);
						if (i <= N && t[i] > N)
							printf("*");

						i = t[i];
					}
					
					printf("\n");
					*/

					break;
				}

				if (cost < d[f[cur]])
				{
					d[f[cur]] = cost;
					if (!viz[ f[cur] ])
					{
						viz[f[cur]] = 1;
						q[p2] = f[cur];
						p2++;
					}

					t[f[cur]] = cur;
				}
			}
		}

		viz[cur] = 0;
		p1++;
	}

	poz = 0; min = INF;
	for (i = N+1; i <= 2*N; i++)
		if (d[i] < min && !f[i])
		{
			min = d[i];
			poz = i;
		}

	if (poz)
		s+=min, np++;

	return poz;
}

void creste(int ps)
{
	int poz = ps;

	while (t[poz])
	{
		if (poz > N)
		{
			f[ t[poz] ] = poz;
			f[ poz ] = t[poz];
		}

		poz = t[poz];
	}
}

int main()
{
  int K1, K2, i, l1, l2, cost, ps, count, poz;

  for (i = 0; i < NMAX; i++)
  {
    v[i] = (unsigned char *) malloc(NMAX * sizeof(unsigned char));
    c[i] = (unsigned char *) malloc(NMAX * sizeof(unsigned char));
  }

	freopen("input.txt", "r", stdin);

	scanf("%d %d", &N, &M);

  memset(nv, 0, sizeof(nv));

  for (K1 = 1; K1 <= N; K1++)
  {
    nv[K1] = M;

    for (K2 = 1; K2 <= M; K2++)
    {
      scanf("%d", &v[K1][K2-1]);
      c[K1][N + v[K1][K2-1]] = abs(K1 - v[K1][K2-1]);
      v[K1][K2-1] += N;
    }
  }

  memset(f, 0, sizeof(f));

  np = 0;
	while ((ps = eflux()) > 0)
	{
		creste(ps);
	}

  freopen("output.txt", "w", stdout);

	printf("%d\n", s);
	for (i = 1; i <= N; i++)
			printf("%d\n", f[i] - N);

	return 0;
}
