/* Time Complexity: O(N*logN + N^2) */

#include <stdio.h>
#include <math.h>
#include <string.h>
#define filein "INPUT.TXT"
#define fileout "OUTPUT.TXT"
#define maxn 1111

long x[maxn], y[maxn];
int stack[maxn], o[maxn], oaux[maxn], inside[maxn], outside[maxn];
int smn, i, j, k, m, n, p, a, b, c, d, dnew, dmax, N;

long dist2d(long xa, long ya, long xb, long yb)
{
return (xa-xb)*(xa-xb)+(ya-yb)*(ya-yb);
}

long semn(long a, long b, long c, long x, long y)
{
long r = a*x + b*y + c;

if (r == 0) return 0;
else
  if (r > 0) return 1;
else
  return -1;
}

void sort(int li, int ls)
{
if (ls > li)
  {
    sort(li, (li+ls)>>1);
    sort(((li+ls)>>1)+1, ls);

    k = li-1;
    i = li;
    m = (li+ls)>>1;
    j = m+1;

    while (i <= m && j <= ls)
      {
        k++;

        if (x[o[i]] < x[o[j]] ||
           (x[o[i]] == x[o[j]] && y[o[i]] < y[o[j]]))
          {
            oaux[k]=o[i];
            i++;
          }
        else
          {
            oaux[k]=o[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            oaux[k] = o[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            oaux[k] = o[i];
          }
      }

    for (k = li; k <= ls; k++)
      o[k] = oaux[k];
  }
}

void maxdist(int& p1, int& p2)
{
if (n <= 4)
  {
    for (dmax = 0, i = 1; i < N; i++)
      if (!outside[i])
        for (j = i+1; j <= N; j++)
          if (!outside[j])
          {
            d = dist2d(x[i], y[i], x[j], y[j]);

            if (d > dmax)
              dmax = d, p1 = i, p2 = j;
          }
  }
else
  {
    /* Compute the convex hull */

    memset(inside, 0, sizeof(inside));

    for (i = 1; i <= N; i++)
        if (!outside[o[i]])
        {
          stack[1] = i;
          break;
        }

    for (i++; i <= N; i++)
        if (!outside[o[i]])
        {
          stack[2] = i;
          inside[i] = 1;
        }

    i = 2;

    /* Step 1 */
    for (p = 3; p <= N; p++)
      {
        if (outside[o[p]])
          continue;
      
        smn = -1;
        while (smn<0)
          {
            if (i == 1)
              {
                i++;
                stack[i] = p;
                inside[p] = 1;
                smn = 0;
              }
            else
              {
                a = y[o[stack[i-1]]]-y[o[stack[i]]];
                b = x[o[stack[i]]]-x[o[stack[i-1]]];
                c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

                smn = semn(a,b,c,x[o[p]],y[o[p]]);

                if (smn >= 0)
	                {
	                  i++;
	                  stack[i] = p;
	                  inside[p] = 1;
	                }
                else
	                {
	                  inside[stack[i]] = 0;
	                  i--;
	                }
              }
          }
      }

    /* Step 2 */
    for (p = N; p >= 1; p--)
      if (!inside[p])
        {
          if (outside[o[p]])
            continue;

          smn = -1;
          while (smn < 0)
            {
              if (i==1)
	              {
	                i++;
	                stack[i] = p;
	                inside[p] = 1;
	                smn = 0;
	              }
              else
	              {
	                a = y[o[stack[i-1]]]-y[o[stack[i]]];
	                b = x[o[stack[i]]]-x[o[stack[i-1]]];
	                c = x[o[stack[i-1]]]*y[o[stack[i]]]-x[o[stack[i]]]*y[o[stack[i-1]]];

	                smn = semn(a,b,c,x[o[p]],y[o[p]]);
	                if (smn >= 0)
	                  {
	                    i++;
	                    stack[i] = p;
	                    inside[p] = 1;
	                  }
	                else
	                  {
	                    inside[stack[i]] = 0;
	                    i--;
	                  }
	              }
            }
        }

    m = i - 1;
    i = j = 1;
    dmax = 0;

    while (i <= m)
      {
        dnew = d = dist2d(x[o[stack[i]]], y[o[stack[i]]], x[o[stack[j]]], y[o[stack[j]]]);
        if (d > dmax)
          dmax = d, p1 = o[stack[i]], p2 = o[stack[j]];

        do
          {
            j++;
            if (j > m)
              j = 1;

            d = dnew;
            dnew = dist2d(x[o[stack[i]]], y[o[stack[i]]], x[o[stack[j]]], y[o[stack[j]]]);
            if (dnew > dmax)
              dmax = dnew, p1 = o[stack[i]], p2 = o[stack[j]];
          }
        while (dnew > d);

        j--;
        if (j < 1)
          j = m;

        i++;
      }
  }
}

int main()
{
int p1, p2;

freopen(filein, "r", stdin);
freopen(fileout, "w", stdout);

scanf("%d", &n);
n *= 2;
for (i = 1; i <= n; i++)
  {
    scanf("%ld %ld", &x[i], &y[i]);
    o[i] = i;
  }

sort(1, n);


N = n;
memset(outside, 0, sizeof(outside));

while (n > 0)
{
  maxdist(p1, p2);
  printf("%.2lf %d %d\n", sqrt(dist2d(x[p1], y[p1], x[p2], y[p2])), p1, p2);

  outside[p1] = outside[p2] = 1;
  n -= 2;
}

return 0;
}