#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define maxn 5111

int x[maxn], y[maxn];
long a, b, c, d;
int stack[maxn], o[maxn], oaux[maxn], smn,i,j,k,m,n,p;
char inside[maxn];

long semn(long a,long b,long c,long x,long y)
{
long r = a*x + b*y + c;

if (r == 0) return 0;
else
  if (r>0) return 1;
else
  return -1;
}

long dist2d(long xa,long ya,long xb,long yb)
{
return sqrt((xa-xb)*(xa-xb)+(ya-yb)*(ya-yb));
}

void sort(long li,long ls)
{
if (ls-li==1)
  {
  if (x[o[li]]>x[o[ls]] ||
     (x[o[li]]==x[o[ls]] && y[o[li]]>y[o[ls]]))
    {
    p=o[li]; o[li]=o[ls]; o[ls]=p;
    }
  }
else
if (ls-li>1)
  {
  sort(li,(li+ls)>>1);
  sort(((li+ls)>>1)+1,ls);

  k=li-1;
  i=li;
  m=(li+ls)>>1;
  j=m+1;

  while (i<=m && j<=ls)
    {
    k++;

    if (x[o[i]]<x[o[j]] ||
       (x[o[i]]==x[o[j]] && y[o[i]]<y[o[j]]))
      {
      oaux[k]=o[i];
      i++;
      }
    else
      {
      oaux[k]=o[j];
      j++;
      }
    }

  if (i<=m)
    {
    for (j=i;j<=m;j++)
      {
      k++;
      oaux[k]=o[j];
      }
    }
  else
    {
    for (i=j;i<=ls;i++)
      {
      k++;
      oaux[k]=o[i];
      }
    }

  for (k=li;k<=ls;k++)
    o[k]=oaux[k];
  }
}

int main()
{
freopen("INPUT.TXT", "r", stdin);
freopen("OUTPUT.TXT", "w", stdout);

scanf("%ld",&n);
for (i=1;i<=n;i++)
  {
  scanf("%d %d", &x[i],&y[i]);
  o[i]=i;
  }

sort(1,n);

/* Compute convex hull */
memset(inside,0,sizeof(inside));
stack[1]=1; stack[2]=2; inside[2]=1; i=2;

/* Step 1 */
for (p=3;p<=n;p++)
  {
  smn=-1;
  while (smn<0)
    {
    if (i==1)
      {
      i++;
      stack[i]=p;
      inside[p]=1;
      smn=0;
      }
    else
      {
      a=y[o[stack[i-1]]]-y[o[stack[i]]];
      b=x[o[stack[i]]]-x[o[stack[i-1]]];
      c=((long)x[o[stack[i-1]]] * (long)y[o[stack[i]]]) -
        ((long)x[o[stack[i]]] * (long)y[o[stack[i-1]]]);

      smn=semn(a,b,c,x[o[p]],y[o[p]]);
      if (smn>=0)
	{
	i++;
	stack[i]=p;
	inside[p]=1;
	}
      else
	{
	inside[stack[i]]=0;
	i--;
	}
      }
    }
  }

/* Step 2 */
for (p=n;p>=1;p--)
  if (!inside[p])
    {
    smn=-1;
    while (smn<0)
      {
      if (i==1)
	{
	i++;
	stack[i]=p;
	inside[p]=1;
	smn=0;
	}
      else
	{
      a=y[o[stack[i-1]]]-y[o[stack[i]]];
      b=x[o[stack[i]]]-x[o[stack[i-1]]];
      c=((long)x[o[stack[i-1]]] * (long)y[o[stack[i]]]) -
        ((long)x[o[stack[i]]] * (long)y[o[stack[i-1]]]);

	smn=semn(a,b,c,x[o[p]],y[o[p]]);
	if (smn>=0)
	  {
	  i++;
	  stack[i]=p;
	  inside[p]=1;
	  }
	else
	  {
	  inside[stack[i]]=0;
	  i--;
	  }
	}
      }
    }


printf("%d\n", i - 1);
for (k=1;k<i;k++)
  printf("%d %d\n", x[o[stack[k]]], y[o[stack[k]]]);

  return 0;
}