{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

{
  Time Complexity : O(N * N)
  Memory used     : O(N * sqrt(N))  :)
}

Program _ALIENS_;

const MAXN = 266;
      step = 45;
      maxstep = 48;
      filein = 'INPUT.TXT';
      fileout = 'OUTPUT.TXT';

type intlinie = array [0..MAXN] of integer;
     pintlinie = ^intlinie;
     bytelinie = array [0..MAXN] of byte;
     pbytelinie = ^bytelinie;
     charlinie = array [0..MAXN] of char;

var max_ant, max_curr : intlinie;
    max_step : array [0..maxstep] of pintlinie;
    pred_step : array [0..maxstep] of pbytelinie;
    s1 , s2, scomun : charlinie;
    i, j, k, l, lOK, M, N, nsteps, pozi, pozj, istart, d : integer;

function getsir(var s : charlinie) : integer;
var ch : char;
    l : integer;
begin
repeat
  read(ch);
until (ch in ['a'..'z']);

l := 0;
while (ch in ['a'..'z']) do
  begin
    inc(l);
    s[l] := ch;
    read(ch);
  end;

getsir := l;
end;

begin
{ datele de intrare }
assign(input, filein);
reset(input);

M := getsir(s1);
N := getsir(s2);
close(input);

{ alocare dinamica }
for i := 0 to maxstep do
  begin
    new(max_step[i]);
    new(pred_step[i]);
  end;

{ programare dinamica }
for j := 0 to N do
  begin
    max_curr[j] := 0;
    max_step[0]^[j] := 0;
  end;
nsteps := 0;

for i := 1 to M do
  begin
    for j := 0 to N do
      max_ant[j] := max_curr[j];

    max_curr[0] := 0;
    for j := 1 to N do
      if (s1[i] = s2[j]) then
        max_curr[j] := 1 + max_ant[j-1]
      else
        begin
          if (max_ant[j] > max_curr[j-1]) then
            max_curr[j] := max_ant[j]
          else
            max_curr[j] := max_curr[j-1];
        end;

    if (i mod step = 0) then
      begin
        inc(nsteps);
        for j := 0 to N do
          max_step[nsteps]^[j] := max_curr[j];
      end;
  end;

{ datele de iesire }
assign(output, fileout);
rewrite(output);

{
writeln(max_curr[N]);
}

l := max_curr[N];
lOK := l;

pozi := M;
pozj := N;

{ reconstructia solutiei }
for k := nsteps downto 0 do
  begin
    istart := k*step;

    if (istart < pozi) then
      begin
        for j := 0 to N do
          max_curr[j] := max_step[k]^[j];

        for i := istart+1 to pozi do
          begin
            d := i-istart;

            for j := 0 to N do
              max_ant[j] := max_curr[j];

            max_curr[0] := 0;
            pred_step[d]^[0] := 2;

            for j := 1 to N do
              if (s1[i] = s2[j]) then
                begin
                  max_curr[j] := 1 + max_ant[j-1];
                  pred_step[d]^[j] := 1;
                end
              else
                begin
                  if (max_ant[j] > max_curr[j-1]) then
                    begin
                      max_curr[j] := max_ant[j];
                      pred_step[d]^[j] := 2;
                    end
                  else
                    begin
                      max_curr[j] := max_curr[j-1];
                      pred_step[d]^[j] := 3;
                    end
                end;
          end;

        while (pozi > istart) do
          begin
            if (pred_step[pozi-istart]^[pozj] = 1) then
              begin
                scomun[l] := s2[pozj];
                dec(l);
                dec(pozi);
                dec(pozj);
              end
            else
            if (pred_step[pozi-istart]^[pozj] = 2) then
              dec(pozi)
            else
              dec(pozj);
          end;
      end;
  end;

for i := 1 to lOK do
  write(scomun[i]);

close(output);

end.